searchData={"items":[{"type":"module","title":"Bonny","doc":"Extend the Kubernetes API and implement CustomResourceDefinitions lifecycles in Elixir.","ref":"Bonny.html"},{"type":"module","title":"Bonny.API.CRD","doc":"A Custom Resource Definition.\n\nThe `%Bonny.API.CRD{}` struct contains the fields `group`, `resource_type`,\n`scope` and `version`. New definitions can be created directly, using the\n`new!/1` function.","ref":"Bonny.API.CRD.html"},{"type":"function","title":"Bonny.API.CRD.fetch/2","doc":"","ref":"Bonny.API.CRD.html#fetch/2"},{"type":"function","title":"Bonny.API.CRD.get/3","doc":"","ref":"Bonny.API.CRD.html#get/3"},{"type":"function","title":"Bonny.API.CRD.get_and_update/3","doc":"","ref":"Bonny.API.CRD.html#get_and_update/3"},{"type":"function","title":"Bonny.API.CRD.kind_to_names/2","doc":"Build a map of names form the given kind.\n\n#","ref":"Bonny.API.CRD.html#kind_to_names/2"},{"type":"function","title":"Examples - Bonny.API.CRD.kind_to_names/2","doc":"iex> Bonny.API.CRD.kind_to_names(\"SomeKind\")\n    %{singular: \"somekind\", plural: \"somekinds\", kind: \"SomeKind\", shortNames: []}\n\n  The `:inflex` library is used to generate the plural form.\n\n    iex> Bonny.API.CRD.kind_to_names(\"Hero\")\n    %{singular: \"hero\", plural: \"heroes\", kind: \"Hero\", shortNames: []}\n\n  Accepts an optional list of abbreviations as second argument.\n\n    iex> Bonny.API.CRD.kind_to_names(\"SomeKind\", [\"sk\", \"some\"])\n    %{singular: \"somekind\", plural: \"somekinds\", kind: \"SomeKind\", shortNames: [\"sk\", \"some\"]}","ref":"Bonny.API.CRD.html#kind_to_names/2-examples"},{"type":"function","title":"Bonny.API.CRD.new!/1","doc":"Creates a new %Bonny.API.CRD{} struct from the given values. `:scope` is\noptional and defaults to `:Namespaced`.","ref":"Bonny.API.CRD.html#new!/1"},{"type":"function","title":"Bonny.API.CRD.to_manifest/1","doc":"Converts the internally used structure to a map representing a kubernetes CRD manifest.","ref":"Bonny.API.CRD.html#to_manifest/1"},{"type":"type","title":"Bonny.API.CRD.names_t/0","doc":"Defines the names section of the CRD.\n\n- `plural`: name to be used in the URL: /apis/ / /  - e.g. crontabs\n- `singular`: singular name to be used as an alias on the CLI and for display - e.g. crontab\n- `kind`: is normally the CamelCased singular type. Your resource manifests use this. - e.g. CronTab\n- `shortnames`: allow shorter string to match your resource on the CLI - e.g. [ct]","ref":"Bonny.API.CRD.html#t:names_t/0"},{"type":"type","title":"Bonny.API.CRD.t/0","doc":"A Custom Resource Definition.\n\n- `scope`: either Namespaced or Cluster\n- `group`: group name to use for REST API: /apis/ / , defaults to the group in config.exs\n- `names`: see `names_t`\n- `versions`: list of API Version modules for this Resource, defaults to the versions in config.exs","ref":"Bonny.API.CRD.html#t:t/0"},{"type":"module","title":"Bonny.API.ResourceEndpoint","doc":"Defines the API Endpoint for a Kubernetes resource.\n\nThe struct contains the fields `group`, `resource_type`, `scope` and `version`.\nNew definitions can be created directly or using the `new!/1` function.","ref":"Bonny.API.ResourceEndpoint.html"},{"type":"function","title":"Bonny.API.ResourceEndpoint.new!/1","doc":"Creates a new %Bonny.API.ResourceEndpoint{} struct from the given values. `:scope` is\noptional and defaults to `:Namespaced`.","ref":"Bonny.API.ResourceEndpoint.html#new!/1"},{"type":"function","title":"Bonny.API.ResourceEndpoint.new!/3","doc":"Creates a new %Bonny.API.ResourceEndpoint{} struct from `apiVersion` and `kind`.\nThe scope can be passed as a third optional parameter.\n\n### Examples\n\n    iex> Bonny.API.ResourceEndpoint.new!(\"apps/v1\", \"Deployment\")\n    %Bonny.API.ResourceEndpoint{group: \"apps\", resource_type: \"deployments\", scope: :Namespaced, version: \"v1\"}\n\n    iex> Bonny.API.ResourceEndpoint.new!(\"v1\", \"Pod\")\n    %Bonny.API.ResourceEndpoint{group: nil, resource_type: \"pods\", scope: :Namespaced, version: \"v1\"}\n\n    iex> Bonny.API.ResourceEndpoint.new!(\"rbac.authorization.k8s.io/v1\", \"ClusterRoleBinding\", :Cluster)\n    %Bonny.API.ResourceEndpoint{group: \"rbac.authorization.k8s.io\", resource_type: \"clusterrolebindings\", scope: :Cluster, version: \"v1\"}\n\n    iex> Bonny.API.ResourceEndpoint.new!(\"foo/bar/v1\", \"ClusterRoleBinding\", :Cluster)\n    ** (ArgumentError) The api_version \"foo/bar/v1\" cannot be parsed. It contains more than one slash (/).","ref":"Bonny.API.ResourceEndpoint.html#new!/3"},{"type":"function","title":"Bonny.API.ResourceEndpoint.resource_api_version/1","doc":"Gets apiVersion of the actual resources.","ref":"Bonny.API.ResourceEndpoint.html#resource_api_version/1"},{"type":"function","title":"Examples - Bonny.API.ResourceEndpoint.resource_api_version/1","doc":"Returns apiVersion for an operator\n\n    iex> Bonny.API.ResourceEndpoint.resource_api_version(%Bonny.API.ResourceEndpoint{group: \"hello.example.com\", version: \"v1\", scope: :namespaced, resource_type: \"foos\"})\n    \"hello.example.com/v1\"\n\n  Returns apiVersion for `apps` resources\n\n    iex> Bonny.API.ResourceEndpoint.resource_api_version(%Bonny.API.ResourceEndpoint{group: \"apps\", version: \"v1\", scope: :namespaced, resource_type: \"foos\"})\n    \"apps/v1\"\n\n  Returns apiVersion for `core` resources\n\n    iex> Bonny.API.ResourceEndpoint.resource_api_version(%Bonny.API.ResourceEndpoint{group: \"\", version: \"v1\", scope: :namespaced, resource_type: \"foos\"})\n    \"v1\"\n\n    iex> Bonny.API.ResourceEndpoint.resource_api_version(%Bonny.API.ResourceEndpoint{group: nil, version: \"v1\", scope: :namespaced, resource_type: \"foos\"})\n    \"v1\"","ref":"Bonny.API.ResourceEndpoint.html#resource_api_version/1-examples"},{"type":"type","title":"Bonny.API.ResourceEndpoint.t/0","doc":"A Resource API Definition. Also see [Kubernetes API terminology](https://kubernetes.io/docs/reference/using-api/api-concepts/#standard-api-terminology).\n\n* `group`: The API group used for REST API: /apis/ / , e.g. \"apps\" or \"example.com\"\n* `resource_type`: The plural form of the resource name\n* `scope`: `:Namespaced` or `:Cluster` - defaults to `:Namespaced`\n* `version`: The API version used for REST API: /apis/ / , e.g. \"v1\" or \"v1alpha1\"","ref":"Bonny.API.ResourceEndpoint.html#t:t/0"},{"type":"behaviour","title":"Bonny.API.Version","doc":"Describes an API version of a custom resource.\n\nThe `%Bonny.API.Version{}` struct contains the fields required to build the\nmanifest for this version.\n\nThis module is meant to be `use`d by a module representing the\nAPI version of a custom resource. The using module has to define\nthe function `manifest/0`.\n\nThe macro `defaults/1` is imported to the using module. It can be used to\nsimplify getting started. The first argument is the version's name (e.g. \"v1\").\nIf no name is passed, The macro will use the using module's name as the\nversion name.\n\n**Note: The `:storage` flag has to be `true` for exactly one version of a\nCRD.**\n\n    defmodule MyOperator.API.V1.CronTab do\n      use Bonny.API.Version\n\n      def manifest() do\n        struct!(defaults(), storage: true)\n      end\n\nUse the `manifest/0` callback to override the defaults, e.g. add a schema.\nPipe your struct into `add_observed_generation_status/1` - which is imported\ninto the using module - if you use the\n`Bonny.Pluggable.SkipObservedGenerations` step in your controller\n\n    defmodule MyOperator.API.V1.CronTab do\n      use Bonny.API.Version\n\n      def manifest() do\n        struct!(\n          defaults(),\n          storage: true,\n          schema: %{\n            openAPIV3Schema: %{\n              type: :object,\n              properties: %{\n                spec: %{\n              }\n            }\n          }\n        )\n      end","ref":"Bonny.API.Version.html"},{"type":"function","title":"Bonny.API.Version.add_conditions/1","doc":"Adds the status subresource if it hasn't been added before\nand adds the schema for the `.status.conditions` array.\n\n#","ref":"Bonny.API.Version.html#add_conditions/1"},{"type":"function","title":"Example - Bonny.API.Version.add_conditions/1","doc":"iex> %Bonny.API.Version{}\n    ...> |> Bonny.API.Version.add_conditions()\n    ...> |> Map.take([:subresources, :schema])\n    %{\n      subresources: %{status: %{}},\n      schema: %{\n        openAPIV3Schema: %{\n          type: :object,\n          properties: %{\n            status: %{\n              type: :object,\n              properties: %{\n                conditions: %{\n                  type: :array,\n                  items: %{\n                    type: :object,\n                    properties: %{\n                      type: %{type: :string},\n                      status: %{type: :string, enum: [\"True\", \"False\"]},\n                      message: %{type: :string},\n                      lastTransitionTime: %{type: :string, format: :\"date-time\"},\n                      lastHeartbeatTime: %{type: :string, format: :\"date-time\"}\n                    }\n                  }\n                }\n              }\n            }\n          },\n          \"x-kubernetes-preserve-unknown-fields\": true,\n        }\n      }\n    }","ref":"Bonny.API.Version.html#add_conditions/1-example"},{"type":"function","title":"Bonny.API.Version.add_observed_generation_status/1","doc":"Adds the status subresource if it hasn't been added before\nand adds a field .status.observedGeneration of type integer\nto the OpenAPIV3Schema.\n\n#","ref":"Bonny.API.Version.html#add_observed_generation_status/1"},{"type":"function","title":"Example - Bonny.API.Version.add_observed_generation_status/1","doc":"iex> %Bonny.API.Version{}\n    ...> |> Bonny.API.Version.add_observed_generation_status()\n    ...> |> Map.take([:subresources, :schema])\n    %{\n      subresources: %{status: %{}},\n      schema: %{\n        openAPIV3Schema: %{\n          type: :object,\n          properties: %{\n            status: %{\n              type: :object,\n              properties: %{\n                observedGeneration: %{type: :integer}\n              }\n            }\n          },\n          \"x-kubernetes-preserve-unknown-fields\": true,\n        }\n      }\n    }","ref":"Bonny.API.Version.html#add_observed_generation_status/1-example"},{"type":"macro","title":"Bonny.API.Version.defaults/0","doc":"Returns a `Bonny.API.Version` struct with default values. Use this and pipe\nit into `struct!()` to override the defaults in your `manifest/0` callback.","ref":"Bonny.API.Version.html#defaults/0"},{"type":"callback","title":"Bonny.API.Version.manifest/0","doc":"Return a `%Bonny.API.Version{}` struct representing the manifest for this\nversion of the CRD API.","ref":"Bonny.API.Version.html#c:manifest/0"},{"type":"type","title":"Bonny.API.Version.printer_column_t/0","doc":"Defines an [additional printer column](https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definitions/#additional-printer-columns).","ref":"Bonny.API.Version.html#t:printer_column_t/0"},{"type":"type","title":"Bonny.API.Version.schema_t/0","doc":"Defines an [OpenAPI V3 Schema](https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definitions/#specifying-a-structural-schema).\n\nThe typespec might be incomplete. Please open a PR with your additions and links to the relevant documentation, thanks.","ref":"Bonny.API.Version.html#t:schema_t/0"},{"type":"type","title":"Bonny.API.Version.subresources_t/0","doc":"Defines a version of a custom resource. Refer to the\n[CRD versioning documentation](https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definition-versioning/)","ref":"Bonny.API.Version.html#t:subresources_t/0"},{"type":"type","title":"Bonny.API.Version.t/0","doc":"","ref":"Bonny.API.Version.html#t:t/0"},{"type":"module","title":"Bonny.Axn","doc":"Describes a resource action event.\n\nThis is the token passed to all steps of your operator and controller\npipeline.\n\nThis module gets imported to your controllers where you should use the\nfunctions `register_descendant/3`, `update_status/2` and the ones to register\nevents: `success_event/2`, `failure_event/2` and/or `register_event/6`. Note\nthat these functions raise exceptions if those resources have already been\napplied to the cluster.\n\nThe `register_before_*` functions can be used in `Pluggable` steps in order\nto register callbacks that are called before applying resources to the\ncluster. Have a look at `Bonny.Pluggable.Logger` for a use case.","ref":"Bonny.Axn.html"},{"type":"module","title":"Action event fields - Bonny.Axn","doc":"These fields contain information on the action event that occurred.\n\n  * `action` - the action that triggered this event\n  * `resource` - the resource the action was applied to\n  * `conn` - the connection to the cluster the event occurred\n  * `operator` - the operator that discovered and dispatched the event\n  * `controller` - the controller handling the event and its init opts\n\n## Reaction fields\n\n  * `descendants` - descending resources defined by the handling controller\n  * `status` - the data to be applied to the status subresource\n  * `events` - Kubernetes events regarding the resource to be applied to the cluster","ref":"Bonny.Axn.html#module-action-event-fields"},{"type":"module","title":"Pipeline fields - Bonny.Axn","doc":"* `halted` - the boolean status on whether the pipeline was halted\n  * `assigns` - shared user data as a map\n  * `private` - shared library data as a map\n  * `states` - The states for status, events and descendants","ref":"Bonny.Axn.html#module-pipeline-fields"},{"type":"function","title":"Bonny.Axn.apply_descendants/2","doc":"Applies the dependants to the cluster in groups.\nIf `:create_events` is true, will create an event for each successful apply.\nAlways creates events upon failed applies.\n\n## Options\n\n`:create_events` - Whether events should be created upon success. Defaults to `true`\n\nAll further options are passed to `K8s.Client.apply/2`","ref":"Bonny.Axn.html#apply_descendants/2"},{"type":"function","title":"Bonny.Axn.apply_status/2","doc":"Applies the status to the resource's status subresource in the cluster.\nIf no status was specified, :noop is returned.","ref":"Bonny.Axn.html#apply_status/2"},{"type":"macro","title":"Bonny.Axn.are_descendants_applied/1","doc":"","ref":"Bonny.Axn.html#are_descendants_applied/1"},{"type":"macro","title":"Bonny.Axn.are_events_emitted/1","doc":"","ref":"Bonny.Axn.html#are_events_emitted/1"},{"type":"function","title":"Bonny.Axn.clear_events/1","doc":"Empties the list of events without emitting them.","ref":"Bonny.Axn.html#clear_events/1"},{"type":"function","title":"Bonny.Axn.emit_events/1","doc":"Emits the events created for this Axn.","ref":"Bonny.Axn.html#emit_events/1"},{"type":"function","title":"Bonny.Axn.failure_event/2","doc":"Registers a failure event to the `%Axn{}` token to be emitted by Bonny.","ref":"Bonny.Axn.html#failure_event/2"},{"type":"function","title":"Bonny.Axn.identifier/1","doc":"Returns an identifier of an action event (resource and action) as tuple.\nCan be used in logs and similar.","ref":"Bonny.Axn.html#identifier/1"},{"type":"macro","title":"Bonny.Axn.is_status_applied/1","doc":"","ref":"Bonny.Axn.html#is_status_applied/1"},{"type":"function","title":"Bonny.Axn.new!/1","doc":"","ref":"Bonny.Axn.html#new!/1"},{"type":"function","title":"Bonny.Axn.register_after_processed/2","doc":"Registers a callback to be invoked at the very end of an  action event's\nprocessing by the operator.\n\nCallbacks are invoked in the reverse order they are defined (callbacks\ndefined first are invoked last).","ref":"Bonny.Axn.html#register_after_processed/2"},{"type":"function","title":"Examples - Bonny.Axn.register_after_processed/2","doc":"To log a message after the an event was processed by the operator:\n\n    Bonny.Axn.register_after_processed(axn, fn axn ->\n      Logger.info(\"done\")\n      axn\n    end)","ref":"Bonny.Axn.html#register_after_processed/2-examples"},{"type":"function","title":"Bonny.Axn.register_before_apply_descendants/2","doc":"Registers a callback to be invoked before descendants are applied to the\ncluster.\n\nCallbacks are invoked in the reverse order they are defined (callbacks\ndefined first are invoked last).","ref":"Bonny.Axn.html#register_before_apply_descendants/2"},{"type":"function","title":"Examples - Bonny.Axn.register_before_apply_descendants/2","doc":"To log a message:\n\n    require Logger\n    Bonny.Axn.register_before_apply_status(axn, fn descendants, axn ->\n      Enum.each(descendants, &Logger.info(\"Descending #{&1[\"kind\"]} named #{&1[\"name\"]} is applied to namespace #{&1[\"metadata\"][\"namespace\"]}\"))\n      descendants\n    end)","ref":"Bonny.Axn.html#register_before_apply_descendants/2-examples"},{"type":"function","title":"Bonny.Axn.register_before_apply_status/2","doc":"Registers a callback to be invoked before a status is applied to the\nstatus subresource.\n\nCallbacks are invoked in the reverse order they are defined (callbacks\ndefined first are invoked last).","ref":"Bonny.Axn.html#register_before_apply_status/2"},{"type":"function","title":"Examples - Bonny.Axn.register_before_apply_status/2","doc":"To log a message for the status being applied:\n\n    require Logger\n    Bonny.Axn.register_before_apply_status(axn, fn resource, axn ->\n      Logger.info(\"Status of the #{resource[\"kind\"]} named #{resource[\"metadata\"][\"name\"]} is applied to namespace #{resource[\"metadata\"][\"namespace\"]}\")\n      resource\n    end)","ref":"Bonny.Axn.html#register_before_apply_status/2-examples"},{"type":"function","title":"Bonny.Axn.register_before_emit_event/2","doc":"Registers a callback to be invoked before events are emitted to the\ncluster.\n\nCallbacks are invoked in the reverse order they are defined (callbacks\ndefined first are invoked last).","ref":"Bonny.Axn.html#register_before_emit_event/2"},{"type":"function","title":"Examples - Bonny.Axn.register_before_emit_event/2","doc":"To log a message:\n\n    require Logger\n    Bonny.Axn.register_before_apply_status(axn, fn events, axn ->\n      Logger.info(\"Event of type #{event.event_type} is emitted\")\n      events\n    end)","ref":"Bonny.Axn.html#register_before_emit_event/2-examples"},{"type":"function","title":"Bonny.Axn.register_descendant/3","doc":"Registers a decending object to be applied.\nOwner reference will be added automatically. unless disabled through\nthe option `omit_owner_ref`.\n\nIf you need some resources to be applied before others, use the `group`\noption to indicate which group a resourceis added. Groups are applied in\nascending order. Resources within a group are applied simultaneously.","ref":"Bonny.Axn.html#register_descendant/3"},{"type":"function","title":"Options - Bonny.Axn.register_descendant/3","doc":"* `omit_owner_ref` - when `true`, adding the owner reference is omitted.\n  Default: `false`\n* `group` - Integer (posittive or negative). Controls the order in which\n  descendants are applied to the cluster. Default: `0`","ref":"Bonny.Axn.html#register_descendant/3-options"},{"type":"function","title":"Example - Bonny.Axn.register_descendant/3","doc":"The following code registers a namespace and a pod as descendants. The\nnamespace is assigned to group `-1` as it needs to exist when the pod\nis created within it. With `omit_owner_ref: true`, we indicate that no\nowner reference is created for the namespace.\n\n```\nns = %{\n  \"apiVersion\" => \"v1\",\n  \"kind\" => \"namespace\",\n  \"metadata\" => %{\"name\" => \"my_ns\"}\n}\npod = %{\n  \"apiVersion\" => \"v1\",\n  \"kind\" => \"pod\",\n  \"metadata\" => %{\"namespace\" => \"my_ns\", \"name\" => \"my_pod\"},\n  ...\n}\n\naxn\n|> Bonny.Axn.register_descendant(resource, ns, group: -1, omit_owner_ref: true)\n|> Bonny.Axn.register_descendant(resource, pod)\n```","ref":"Bonny.Axn.html#register_descendant/3-example"},{"type":"function","title":"Bonny.Axn.register_event/6","doc":"Registers a Kubernetes event to the `%Axn{}` token to be emitted by Bonny.","ref":"Bonny.Axn.html#register_event/6"},{"type":"function","title":"Bonny.Axn.set_condition/4","doc":"Sets the condition in the resource status.\n\nThe field `.status.conditions`, if configured in the CRD, nolds a list of\nconditions, their `status` with a `message` and two timestamps. On the\nresource this could look something like this (taken from a Pod):\n\n```\nkind: Pod\nstatus:\n  conditions:\n    - lastTransitionTime: \"2019-10-22T16:29:24Z\"\n      status: \"True\"\n      type: PodScheduled\n    - lastTransitionTime: \"2019-10-22T16:29:24Z\"\n      status: \"True\"\n      type: Initialized\n    - lastTransitionTime: \"2019-10-22T16:29:31Z\"\n      status: \"True\"\n      type: ContainersReady\n    - lastTransitionTime: \"2019-10-22T16:29:31Z\"\n      status: \"True\"\n      type: Ready\n```","ref":"Bonny.Axn.html#set_condition/4"},{"type":"function","title":"Bonny.Axn.success_event/2","doc":"Registers a asuccess event to the `%Axn{}` token to be emitted by Bonny.","ref":"Bonny.Axn.html#success_event/2"},{"type":"function","title":"Bonny.Axn.update_status/2","doc":"Executes `fun` for the resource status and applies the new status\nsubresource. This can be called multiple times.\n\n`fun` should be a function of arity 1. It will be passed the\ncurrent status object and expected to return the updated one.\n\nIf no current status exists, an empty map is passed to `fun`","ref":"Bonny.Axn.html#update_status/2"},{"type":"type","title":"Bonny.Axn.assigns/0","doc":"","ref":"Bonny.Axn.html#t:assigns/0"},{"type":"type","title":"Bonny.Axn.states/0","doc":"","ref":"Bonny.Axn.html#t:states/0"},{"type":"type","title":"Bonny.Axn.t/0","doc":"","ref":"Bonny.Axn.html#t:t/0"},{"type":"module","title":"Bonny.Axn.Test","doc":"Conveniences for testing Axn steps.\n\nThis module can be used in your test cases, like this:\n\n    use ExUnit.Case, async: true\n    use Bonny.Axn.Test\n\nUsing this module will:\n\n  * import all the functions from this module\n  * import all the functions from the `Bonny.Axn` module\n  * import all the functions from the `Pluggable.Token` module","ref":"Bonny.Axn.Test.html"},{"type":"function","title":"Bonny.Axn.Test.assigns/1","doc":"","ref":"Bonny.Axn.Test.html#assigns/1"},{"type":"function","title":"Bonny.Axn.Test.axn/2","doc":"","ref":"Bonny.Axn.Test.html#axn/2"},{"type":"function","title":"Bonny.Axn.Test.descendants/1","doc":"","ref":"Bonny.Axn.Test.html#descendants/1"},{"type":"function","title":"Bonny.Axn.Test.events/1","doc":"","ref":"Bonny.Axn.Test.html#events/1"},{"type":"function","title":"Bonny.Axn.Test.status/1","doc":"","ref":"Bonny.Axn.Test.html#status/1"},{"type":"module","title":"Bonny.CRD","doc":"Represents the `spec` portion of a Kubernetes [CustomResourceDefinition](https://kubernetes.io/docs/tasks/access-kubernetes-api/custom-resources/custom-resource-definitions/) manifest.\n\n> The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource.","ref":"Bonny.CRD.html"},{"type":"function","title":"Bonny.CRD.api_version/1","doc":"Gets group version from CRD spec","ref":"Bonny.CRD.html#api_version/1"},{"type":"function","title":"Examples - Bonny.CRD.api_version/1","doc":"Returns apiVersion for an operator\n\n    iex> Bonny.CRD.api_version(%Bonny.CRD{group: \"hello.example.com\", version: \"v1\", scope: :namespaced, names: %{}})\n    \"hello.example.com/v1\"\n\n  Returns apiVersion for `apps` resources\n\n    iex> Bonny.CRD.api_version(%Bonny.CRD{group: \"apps\", version: \"v1\", scope: :namespaced, names: %{}})\n    \"apps/v1\"\n\n  Returns apiVersion for `core` resources\n\n    iex> Bonny.CRD.api_version(%Bonny.CRD{group: \"\", version: \"v1\", scope: :namespaced, names: %{}})\n    \"v1\"\n\n    iex> Bonny.CRD.api_version(%Bonny.CRD{group: nil, version: \"v1\", scope: :namespaced, names: %{}})\n    \"v1\"","ref":"Bonny.CRD.html#api_version/1-examples"},{"type":"function","title":"Bonny.CRD.default_columns/0","doc":"Default CLI printer columns.\n\nThese are added to the CRDs columns _when_ columns are set.\n\nThe kubernetes API returns these by default when they _are not_ set.","ref":"Bonny.CRD.html#default_columns/0"},{"type":"function","title":"Bonny.CRD.kind/1","doc":"CRD Kind or plural name","ref":"Bonny.CRD.html#kind/1"},{"type":"function","title":"Examples - Bonny.CRD.kind/1","doc":"iex> Bonny.CRD.kind(%Bonny.CRD{names: %{plural: \"greetings\"}, scope: :namespaced, group: \"test\", version: \"v1\"})\n    \"greetings\"","ref":"Bonny.CRD.html#kind/1-examples"},{"type":"function","title":"Bonny.CRD.to_manifest/2","doc":"Generates the map equivalent of the Kubernetes CRD YAML manifest\n\n```yaml\n---\napiVersion: apiextensions.k8s.io/v1beta1\nkind: CustomResourceDefinition\nmetadata:\n  creationTimestamp: null\n  name: widgets.example.com\nspec:\n  group: example.com\n  names:\n    kind: Widget\n    plural: widgets\n  scope: Namespaced\n  version: v1\n```","ref":"Bonny.CRD.html#to_manifest/2"},{"type":"type","title":"Bonny.CRD.t/0","doc":"CRD Spec","ref":"Bonny.CRD.html#t:t/0"},{"type":"module","title":"Bonny.Config","doc":"Operator configuration interface","ref":"Bonny.Config.html"},{"type":"function","title":"Bonny.Config.api_version/0","doc":"Kubernetes APIVersion used. Defaults to `apiextensions.k8s.io/v1`","ref":"Bonny.Config.html#api_version/0"},{"type":"function","title":"Bonny.Config.conn/0","doc":"`K8s.Conn` name used for this operator.","ref":"Bonny.Config.html#conn/0"},{"type":"function","title":"Bonny.Config.controllers/0","doc":"List of all controller modules to watch.\n\nThis *must* be set in config.exs:\n\n```\nconfig :bonny, controllers: [MyController1, MyController2]\n```","ref":"Bonny.Config.html#controllers/0"},{"type":"function","title":"Bonny.Config.group/0","doc":"Kubernetes API Group of this operator","ref":"Bonny.Config.html#group/0"},{"type":"function","title":"Bonny.Config.instance_name/0","doc":"The name of the operator instance.\n\nThis is set via environment variable `BONNY_POD_NAME`","ref":"Bonny.Config.html#instance_name/0"},{"type":"function","title":"Bonny.Config.labels/0","doc":"Labels to apply to all operator resources.\n\n*Note:* These are only applied to the resources that compose the operator itself,\nnot the resources created by the operator.\n\nThis can be set in config.exs:\n\n```\nconfig :bonny, labels: %{foo: \"bar\", quz: \"baz\"}\n```","ref":"Bonny.Config.html#labels/0"},{"type":"function","title":"Bonny.Config.name/0","doc":"The name of the operator.\n\nName must consist of only lowercase letters and hyphens.\n\nDefaults to hyphenated mix project app name. E.g.: `:hello_operator` becomes `hello-operator`","ref":"Bonny.Config.html#name/0"},{"type":"function","title":"Bonny.Config.namespace/0","doc":"The namespace to watch for `Namespaced` CRDs.\n\nDefaults to `default`\n\nThis can be set via environment variable:\n\n```shell\nBONNY_POD_NAMESPACE=prod # specific namespace\n# or\nBONNY_POD_NAMESPACE=__ALL__ # all namespaces\niex -S mix\n```\n\nOr via config.exs:\n```\nconfig :bonny, namespace: \"mynamespace\" # specific namespace\n# or\nconfig :bonny; namespace: :all # all namespaces\n```\n\nConfiguration via environment variable always takes precedence over config.exs.\n\nBonny sets `BONNY_POD_NAMESPACE` on all Kubernetes deployments to the namespace the operator is deployed in.","ref":"Bonny.Config.html#namespace/0"},{"type":"function","title":"Bonny.Config.service_account/0","doc":"Kubernetes service account name to run operator as.\n\n*Note:* if a kube config file is provided, this service account will still be created\nand assigned to pods, but the *config file auth will be used* when making requests to the Kube API.\n\nName must consist of only lowercase letters and hyphens.\n\nDefaults to hyphenated mix project app name. E.g.: `:hello_operator` becomes `hello-operator`","ref":"Bonny.Config.html#service_account/0"},{"type":"function","title":"Bonny.Config.versions/0","doc":"Kubernetes API Versions of this operator","ref":"Bonny.Config.html#versions/0"},{"type":"behaviour","title":"Bonny.Controller","doc":"`Bonny.Controller` defines controller behaviours and generates boilerplate for generating Kubernetes manifests.\n\n> A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API.\n\nControllers allow for simple `add`, `modify`, `delete`, and `reconcile` handling of custom resources in the Kubernetes API.","ref":"Bonny.Controller.html"},{"type":"callback","title":"Bonny.Controller.add/1","doc":"","ref":"Bonny.Controller.html#c:add/1"},{"type":"callback","title":"Bonny.Controller.conn/0","doc":"Bonny.Controller comes with a default implementation which returns Bonny.Config.config()","ref":"Bonny.Controller.html#c:conn/0"},{"type":"callback","title":"Bonny.Controller.delete/1","doc":"","ref":"Bonny.Controller.html#c:delete/1"},{"type":"function","title":"Bonny.Controller.ensure_list_query/1","doc":"","ref":"Bonny.Controller.html#ensure_list_query/1"},{"type":"function","title":"Bonny.Controller.ensure_watch_query/1","doc":"","ref":"Bonny.Controller.html#ensure_watch_query/1"},{"type":"callback","title":"Bonny.Controller.list_operation/0","doc":"Should return an operation to list resources for watching and reconciliation.\n\nBonny.Controller comes with a default implementation","ref":"Bonny.Controller.html#c:list_operation/0"},{"type":"function","title":"Bonny.Controller.list_operation/1","doc":"","ref":"Bonny.Controller.html#list_operation/1"},{"type":"callback","title":"Bonny.Controller.modify/1","doc":"","ref":"Bonny.Controller.html#c:modify/1"},{"type":"callback","title":"Bonny.Controller.reconcile/1","doc":"","ref":"Bonny.Controller.html#c:reconcile/1"},{"type":"behaviour","title":"Bonny.ControllerV2","doc":"Controllers handle action events observed by a resource watch query.\nControllers must be registered at the operator together with the resource\nwatch query. The operator will then delegate events observed by that query for\nprocessing to this controller\n\nControllers use the `Pluggable.StepBuilder` to build a step in the processing\npipeline. In order to use it, a step has to be defined and implemented in the\ncontroller. The step must have the following spec\n\n    step_name(Bonny.Axn.t(), keyword()) :: Bonny.Axn.t()\n\nThe modules `Bonny.Axn` module is imported to your controller. In your event\nhandler step you should use the functions `Bonny.Axn.register_descendant/3`,\n`Bonny.Axn.update_status/2` and the ones to  register events:\n`Bonny.Axn.success_event/2`, `Bonny.Axn.failure_event/2` and/or\n`Bonny.Axn.register_event/6`. Note that these functions raise\nexceptions if those resources have already been applied to the cluster.\n\n## Example\n\nMatch against the struct's `:action` field which is one of `:add`, `:modify`,\n`:reconcile` or `:delete` to provide an implementation for each case.\n\n    defmodule MyOperator.Controller.CronTabController do\n\n      # other steps\n      step :handle_event\n      # other steps\n\n      # apply the resource\n      def handle_event(%Bonny.Axn{action: action, resource: resource} = axn, _opts)\n          when action in [:add, :modify, :reconcile] do\n        success_event(axn)\n      end\n\n      def handle_event(%Bonny.Axn{action: :delete, resource: resource} = axn, _opts) do\n        #\n        axn\n      end\n    end\n\nRegistering your descendants with the `%Bonny.Axn{}` token makes your\ncontroller easier to test. Be sure to add `Bonny.Pluggable.ApplyDescendants`\nas step to your operator in order for the descendants to be applied to the\ncluster.\n\n    defmodule MyOperator.Controller.CronTabController do\n\n      # other steps\n      step :handle_event\n      # other steps\n\n      # apply the resource\n      def handle_event(axn, _opts) do\n        deployment = generate_deployment(axn.resource)\n\n        axn\n        |> register_descendant(deployment)\n        |> success_event()\n      end\n    end\n\nUse `Bonny.Axn.update_status/2` to store API responses or other status data in the\nresource status. Be sure to enable the status subresource in your CRD version\nmodule.\n\n    defmodule MyOperator.Controller.CronTabController do\n\n      # other steps\n      step :handle_event\n      # other steps\n\n      # apply the resource\n      def handle_event(axn, _opts) do\n        response = apply_state(axn.resource)\n\n        axn\n        |> update_status(fn status ->\n          Map.put(status, \"response\", response)\n        end)\n        |> success_event()\n      end\n    end","ref":"Bonny.ControllerV2.html"},{"type":"function","title":"Bonny.ControllerV2.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Bonny.ControllerV2.html#child_spec/1"},{"type":"callback","title":"Bonny.ControllerV2.rbac_rules/0","doc":"","ref":"Bonny.ControllerV2.html#c:rbac_rules/0"},{"type":"function","title":"Bonny.ControllerV2.start_link/1","doc":"","ref":"Bonny.ControllerV2.html#start_link/1"},{"type":"function","title":"Bonny.ControllerV2.to_rbac_rule/1","doc":"","ref":"Bonny.ControllerV2.html#to_rbac_rule/1"},{"type":"type","title":"Bonny.ControllerV2.api/0","doc":"","ref":"Bonny.ControllerV2.html#t:api/0"},{"type":"type","title":"Bonny.ControllerV2.rbac_rule/0","doc":"","ref":"Bonny.ControllerV2.html#t:rbac_rule/0"},{"type":"type","title":"Bonny.ControllerV2.resource/0","doc":"","ref":"Bonny.ControllerV2.html#t:resource/0"},{"type":"type","title":"Bonny.ControllerV2.verb/0","doc":"","ref":"Bonny.ControllerV2.html#t:verb/0"},{"type":"module","title":"Bonny.Event","doc":"Represents a kubernetes event.\nDocumentation: https://kubernetes.io/docs/reference/kubernetes-api/cluster-resources/event-v1/","ref":"Bonny.Event.html"},{"type":"function","title":"Bonny.Event.new!/1","doc":"Creates an event.\n\nOptions: `:reporting_controller`, `:reporting_instance`","ref":"Bonny.Event.html#new!/1"},{"type":"function","title":"Bonny.Event.new!/7","doc":"","ref":"Bonny.Event.html#new!/7"},{"type":"type","title":"Bonny.Event.event_type/0","doc":"Kubernetes events currently support these types.","ref":"Bonny.Event.html#t:event_type/0"},{"type":"type","title":"Bonny.Event.t/0","doc":"See https://kubernetes.io/docs/reference/kubernetes-api/cluster-resources/event-v1/ for field explanations.","ref":"Bonny.Event.html#t:t/0"},{"type":"module","title":"Bonny.EventRecorder","doc":"Records kubernetes events regarding objects controlled by this operator.","ref":"Bonny.EventRecorder.html"},{"type":"function","title":"Bonny.EventRecorder.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Bonny.EventRecorder.html#child_spec/1"},{"type":"function","title":"Bonny.EventRecorder.emit/3","doc":"Create a kubernetes event in the cluster.\nDocumentation: https://kubernetes.io/docs/reference/kubernetes-api/cluster-resources/event-v1/","ref":"Bonny.EventRecorder.html#emit/3"},{"type":"function","title":"Bonny.EventRecorder.start_link/1","doc":"","ref":"Bonny.EventRecorder.html#start_link/1"},{"type":"type","title":"Bonny.EventRecorder.event_key/0","doc":"A map to identify an event.","ref":"Bonny.EventRecorder.html#t:event_key/0"},{"type":"module","title":"Bonny.Mix.Operator","doc":"Encapsulates Kubernetes resource manifests for an operator","ref":"Bonny.Mix.Operator.html"},{"type":"function","title":"Bonny.Mix.Operator.cluster_role/1","doc":"ClusterRole manifest","ref":"Bonny.Mix.Operator.html#cluster_role/1"},{"type":"function","title":"Bonny.Mix.Operator.cluster_role_binding/1","doc":"ClusterRoleBinding manifest","ref":"Bonny.Mix.Operator.html#cluster_role_binding/1"},{"type":"function","title":"Bonny.Mix.Operator.crds/1","doc":"CRD manifests","ref":"Bonny.Mix.Operator.html#crds/1"},{"type":"function","title":"Bonny.Mix.Operator.deployment/2","doc":"Deployment manifest","ref":"Bonny.Mix.Operator.html#deployment/2"},{"type":"function","title":"Bonny.Mix.Operator.find_operators/0","doc":"","ref":"Bonny.Mix.Operator.html#find_operators/0"},{"type":"function","title":"Bonny.Mix.Operator.rbac_rules/1","doc":"","ref":"Bonny.Mix.Operator.html#rbac_rules/1"},{"type":"function","title":"Bonny.Mix.Operator.service_account/1","doc":"ServiceAccount manifest","ref":"Bonny.Mix.Operator.html#service_account/1"},{"type":"module","title":"Bonny.Naming","doc":"Naming functions","ref":"Bonny.Naming.html"},{"type":"function","title":"Bonny.Naming.module_to_kind/1","doc":"Converts an elixir module name to a string for use as the CRD's `kind`.","ref":"Bonny.Naming.html#module_to_kind/1"},{"type":"function","title":"Examples - Bonny.Naming.module_to_kind/1","doc":"iex> Bonny.Naming.module_to_kind(Pod)\n    \"Pod\"\n\n    iex> Bonny.Naming.module_to_kind(Controllers.V1.Pod)\n    \"Pod\"","ref":"Bonny.Naming.html#module_to_kind/1-examples"},{"type":"function","title":"Bonny.Naming.module_version/1","doc":"Extract the CRD API version from the module name. Defaults to `\"v1\"`","ref":"Bonny.Naming.html#module_version/1"},{"type":"function","title":"Examples - Bonny.Naming.module_version/1","doc":"iex> Bonny.Naming.module_version(Pod)\n    \"v1\"\n\n    iex> Bonny.Naming.module_version(Controllers.V1.Pod)\n    \"v1\"\n\n    iex> Bonny.Naming.module_version(Controllers.V1Alpha1.Pod)\n    \"v1alpha1\"","ref":"Bonny.Naming.html#module_version/1-examples"},{"type":"behaviour","title":"Bonny.Operator","doc":"Defines a Bonny operator.\n\nThe operator defines custom resources, watch queries and their\ncontrollers and serves as the entry point to the watching and handling of\nprocesses.\n\nOverall, an operator has the following responsibilities:\n\n* to provide a wrapper for starting and stopping the\n  operator as part of a supervision tree\n\n* To define the resources to be watched together with the\n  controllers which handle action events on those resources.\n\n* to define an initial pluggable pipeline for all action events\n  to pass through\n\n* To define any custom resources ending up in the manifest\n  generated by `mix bonny.gen.manifest`","ref":"Bonny.Operator.html"},{"type":"behaviour","title":"Operators - Bonny.Operator","doc":"An operator is defined with the help of `Bonyy.Operator`. The step\n`:delegate_to_controller` has do be part of the pipeline. It is the step that\ncalls the handling controller for a given action event:\n\n    defmodule MyOperatorApp.Operator do\n      use Bonny.Operator, default_watching_namespace: \"default\"\n\n      # step ...\n      step :delegate_to_controller\n      # step ...\n\n      def controllers(watching_namespace, _opts) do\n        [\n          %{\n            query: K8s.Client.watch(\"my-controller.io\", \"MyCustomResource\", namespace: nil)\n            controller: MyOperator.Controller.MyCustomResourceController\n          }\n        ]\n      end\n\n\n    end","ref":"Bonny.Operator.html#module-operators"},{"type":"callback","title":"Bonny.Operator.controllers/2","doc":"","ref":"Bonny.Operator.html#c:controllers/2"},{"type":"callback","title":"Bonny.Operator.crds/0","doc":"","ref":"Bonny.Operator.html#c:crds/0"},{"type":"type","title":"Bonny.Operator.controller_spec/0","doc":"","ref":"Bonny.Operator.html#t:controller_spec/0"},{"type":"module","title":"Bonny.Operator.LeaderElector","doc":"The leader uses a [Kubernetes\nLease](https://kubernetes.io/docs/concepts/architecture/leases/) to make sure\nthe operator only runs on one single replica (the leader) at the same time.","ref":"Bonny.Operator.LeaderElector.html"},{"type":"module","title":"Enabling the Leader Election - Bonny.Operator.LeaderElector","doc":"> ##","ref":"Bonny.Operator.LeaderElector.html#module-enabling-the-leader-election"},{"type":"module","title":"Functionality still in Beta {: .warning} - Bonny.Operator.LeaderElector","doc":">\n> The leader election is still being tested. Enable it for testing purposes\n> only and please report any issues on Github.\n\nTo enable leader election you have to pass the `enable_leader_election: true` option when [adding the operator to your Supervisor](#adding-the-operator-to-your-supervisor):\n\n```elixir\ndefmodule MyOperator.Application do\n  use Application\n\n  def start(_type, env: env) do\n    children = [\n      {MyOperator.Operator,\n      conn: MyOperator.K8sConn.get!(env),\n      watch_namespace: :all,\n      enable_leader_election: true} # <-- starts the leader elector\n    ]\n\n    opts = [strategy: :one_for_one, name: MyOperator.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"Bonny.Operator.LeaderElector.html#module-functionality-still-in-beta-warning"},{"type":"function","title":"Bonny.Operator.LeaderElector.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Bonny.Operator.LeaderElector.html#child_spec/1"},{"type":"function","title":"Bonny.Operator.LeaderElector.start_link/3","doc":"","ref":"Bonny.Operator.LeaderElector.html#start_link/3"},{"type":"module","title":"Bonny.PeriodicTask","doc":"Register periodically run tasks.\nUse for running tasks as a part of reconciling a CRD with a lifetime, duration, or interval field.\n\n__Note:__ Must be started by your operator.\n\nAdd `Bonny.PeriodicTask.sttart_link(:ok)` to your application.\n\nFunctions are expected to return one of:\n- `:ok` - task will be passed to subsequent calls\n- `{:ok, new_state}` state field will be updated in task and provided to next call\n- `{:stop, reason}` task will be removed from execution loop. Use for tasks opting out of being re-run\n- `any()` - any other result is treated as an error, and the execution loop will be halted","ref":"Bonny.PeriodicTask.html"},{"type":"module","title":"Examples - Bonny.PeriodicTask","doc":"Registering a task\n    iex> Bonny.PeriodicTask.new(:pod_evictor, {PodEvictor, :evict, [reconcile_payload_map]}, 5000)\n\n  Unregistering a task\n    iex> Bonny.PeriodicTask.unregister(:pod_evictor)","ref":"Bonny.PeriodicTask.html#module-examples"},{"type":"function","title":"Bonny.PeriodicTask.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Bonny.PeriodicTask.html#child_spec/1"},{"type":"function","title":"Bonny.PeriodicTask.new/3","doc":"Registers and starts a new task given `Bonny.PeriodicTask` attributes","ref":"Bonny.PeriodicTask.html#new/3"},{"type":"function","title":"Bonny.PeriodicTask.register/1","doc":"Registers and starts a new `Bonny.PeriodicTask`","ref":"Bonny.PeriodicTask.html#register/1"},{"type":"function","title":"Bonny.PeriodicTask.start_link/1","doc":"","ref":"Bonny.PeriodicTask.html#start_link/1"},{"type":"function","title":"Bonny.PeriodicTask.unregister/1","doc":"Unregisters and stops a `Bonny.PeriodicTask`","ref":"Bonny.PeriodicTask.html#unregister/1"},{"type":"type","title":"Bonny.PeriodicTask.t/0","doc":"","ref":"Bonny.PeriodicTask.html#t:t/0"},{"type":"module","title":"Bonny.Pluggable.AddManagedByLabelToDescendants","doc":"Adds the `app.kubernetes.io/managed-by` label to all descendants registered\nwithin the pipeline.\n\nAdd this to your operator or controllers to set this label to a value of\nyour choice.","ref":"Bonny.Pluggable.AddManagedByLabelToDescendants.html"},{"type":"module","title":"Options - Bonny.Pluggable.AddManagedByLabelToDescendants","doc":"* `:managed_by` - Required. The value the label should be set to.\n\n## Examples\n\n    step Bonny.Pluggable.AddManagedByLabelToDescendants,\n      managed_by: Bonny.Config.name()","ref":"Bonny.Pluggable.AddManagedByLabelToDescendants.html#module-options"},{"type":"module","title":"Bonny.Pluggable.AddMissingGVK","doc":"The Kubernetes API sometimes doesn't set the fields `apiVersion` and `kind` on\nitems of a list operation. E.g. if you use `K8s.Client` to get a list of\ndeployments, the deployments won't contains those two fields. This is being\ndiscussed on https://github.com/kubernetes/kubernetes/issues/3030.\n\nBonny sometimes depends on `apiVersion` and `kind` to be defined on the\nresource being handled. This is the case for setting the status, e.g. when\nusing `Bonny.Pluggable.SkipObservedGenerations` or `Bonny.Axn.update_status/2`.\n\nAdd this step to your controller in order to set those values on all resources\nbeing handled.\n\n\n## Examples\n\n    step Bonny.Pluggable.AddMissingGVK,\n      apiVersion: \"apps/v1\",\n      kind: \"Deployment\"","ref":"Bonny.Pluggable.AddMissingGVK.html"},{"type":"module","title":"Bonny.Pluggable.ApplyDescendants","doc":"Applies all the descendants added to the `%Bonny.Axn{}` struct.","ref":"Bonny.Pluggable.ApplyDescendants.html"},{"type":"module","title":"Options - Bonny.Pluggable.ApplyDescendants","doc":"* `:events_for_actions` - List of actions for which events will be created\n    upon successful apply. Defaults to `[:add, :modify]` (Reconcile actions\n    are triggered regularly which would create lots of events for no actions.)\n  * `:force` and `:field_manager` - Options forwarded to `K8s.Client.apply()`.\n\n## Examples\n\n    step Bonny.Pluggable.ApplyDescendants,\n      events_for_actions: [:add, :modify, :reconcile],\n      field_manager: \"MyOperator\",\n      force: true","ref":"Bonny.Pluggable.ApplyDescendants.html#module-options"},{"type":"module","title":"Bonny.Pluggable.ApplyStatus","doc":"Applies the status of the given `%Bonny.Axn{}` struct to the status subresource.\n\n## Options\n\n  * `:force` and `:field_manager` - Options forwarded to `K8s.Client.apply()`.\n\n## Examples\n\n    step Bonny.Pluggable.ApplyStatus, field_manager: \"MyOperator\", force: true","ref":"Bonny.Pluggable.ApplyStatus.html"},{"type":"module","title":"Bonny.Pluggable.Finalizer","doc":"Declare a finalizer and its implementation.\n\n#","ref":"Bonny.Pluggable.Finalizer.html"},{"type":"module","title":"Kubernetes Docs: - Bonny.Pluggable.Finalizer","doc":"* https://kubernetes.io/docs/concepts/overview/working-with-objects/finalizers/\n* https://kubernetes.io/blog/2021/05/14/using-finalizers-to-control-deletion/\n\n> ##","ref":"Bonny.Pluggable.Finalizer.html#module-kubernetes-docs"},{"type":"module","title":"Use with `SkipObservedGenerations` {: .tip} - Bonny.Pluggable.Finalizer","doc":">\n> This step is best used with and placed right after\n> `Bonny.Pluggable.SkipObservedGenerations` in your controller. Have a look at\n> the examples below.\n\n> ##","ref":"Bonny.Pluggable.Finalizer.html#module-use-with-skipobservedgenerations-tip"},{"type":"module","title":"Note for Testing {: .warning} - Bonny.Pluggable.Finalizer","doc":">\n> This step directly updates the resource on the kubernetes\n> cluster. In order to write unit tests, you therefore want to use\n> `K8s.Client.DynamicHTTPProvider` in order to mock the calls to Kubernetes.\n\n#","ref":"Bonny.Pluggable.Finalizer.html#module-note-for-testing-warning"},{"type":"module","title":"Examples - Bonny.Pluggable.Finalizer","doc":"See `t:options/0`, `t:finalizer_impl/0` and `t:add_to_resource/0` for more\ninfos on the options.\n\nBy default, a missing finalizer is not added to the resource.\n\n    step Bonny.Pluggable.SkipObservedGenerations\n    step Bonny.Pluggable.Finalizer,\n      id: \"example.com/cleanup\",\n      impl: &__MODULE__.cleanup/1\n\nSet `add_to_resource` to true in order for Bonny to always add it.\n\n    step Bonny.Pluggable.SkipObservedGenerations\n    step Bonny.Pluggable.Finalizer,\n      id: \"example.com/cleanup\",\n      impl: &__MODULE__.cleanup/1,\n      add_to_resource: true\n\nOr make it depending on the event/resource and enable logs.\n\n    step Bonny.Pluggable.SkipObservedGenerations\n    step Bonny.Pluggable.Finalizer,\n      id: \"example.com/cleanup\",\n      impl: &__MODULE__.cleanup/1,\n      add_to_resource: &__MODULE__.deletion_policy_not_abandon/1,\n      log: :debug","ref":"Bonny.Pluggable.Finalizer.html#module-examples"},{"type":"type","title":"Bonny.Pluggable.Finalizer.add_to_resource/0","doc":"Boolean or callback of arity 1 to tell Bonny whether or not to add the\nfinalizer to the resource if it is missing. If it is a callback, it receives\nthe `%Bonny.Axn{}` token and shoulr return a `boolean`.","ref":"Bonny.Pluggable.Finalizer.html#t:add_to_resource/0"},{"type":"type","title":"Bonny.Pluggable.Finalizer.finalizer_impl/0","doc":"The implementation of the finalizer. This is a function of arity 1 which is\ncalled when the resource is deleted. It receives the `%Bonny.Axn{}` token as\nargument and should return the same.","ref":"Bonny.Pluggable.Finalizer.html#t:finalizer_impl/0"},{"type":"type","title":"Bonny.Pluggable.Finalizer.options/0","doc":"- `id` - Fully qualified finalizer identifier\n- `impl` - The implementation of the finalizer. See `t:finalizer_impl/0`\n- `add_to_resource` - (otional) whether Bonny should add the finalizer to the\n  resource if it is missing. See `t:add_to_resource/0`\n  `%Bonny.Axn{}` token. Defaults to `false`.\n- `log_level` - (optional) Log level used for logging by this step. `:disable` for no\n  logs. Defaults to `:disable`","ref":"Bonny.Pluggable.Finalizer.html#t:options/0"},{"type":"module","title":"Bonny.Pluggable.Logger","doc":"A pluggable step for logging basic action event information in the format:\n\n    {\"NAMESPACE/OBJECT_NAME\", API_VERSION, \"Kind=KIND, Action=ACTION\"}\n\nExample:\n\n    {\"default/my-object\", \"example.com/v1\", \"Kind=MyCustomResource, Action=:add\"} - Processing event\n    {\"default/my-object\", \"example.com/v1\", \"Kind=MyCustomResource, Action=:add\"} - Applying status\n    {\"default/my-object\", \"example.com/v1\", \"Kind=MyCustomResource, Action=:add\"} - Emitting Normal event\n    {\"default/my-object\", \"example.com/v1\", \"Kind=MyCustomResource, Action=:add\"} - Applying descendant {\"default/nginx\", \"apps/v1\", \"Kind=Deployment\"}\n\nTo use it, just add a step to the desired module.\n\n    step Bonny.Pluggable.Logger, level: :debug","ref":"Bonny.Pluggable.Logger.html"},{"type":"module","title":"Options - Bonny.Pluggable.Logger","doc":"* `:level` - The log level at which this plug should log its request info.\n    Default is `:info`.\n    The [list of supported levels](https://hexdocs.pm/logger/Logger.html#module-levels)\n    is available in the `Logger` documentation.","ref":"Bonny.Pluggable.Logger.html#module-options"},{"type":"function","title":"Bonny.Pluggable.Logger.call/2","doc":"","ref":"Bonny.Pluggable.Logger.html#call/2"},{"type":"function","title":"Bonny.Pluggable.Logger.init/1","doc":"","ref":"Bonny.Pluggable.Logger.html#init/1"},{"type":"module","title":"Bonny.Pluggable.SkipObservedGenerations","doc":"Halts the pipelines for a defined list of actions if the observed generation\nequals the resource's generation. It also sets the observed generation value\nbefore applying the resource status to the cluster.","ref":"Bonny.Pluggable.SkipObservedGenerations.html"},{"type":"module","title":"Options - Bonny.Pluggable.SkipObservedGenerations","doc":"* `:actions` - The actions for which this rule applies. Defaults to `[:add, :modify]`.\n* `:observed_generation_key` - The resource status key where the observed generation is stored. This will be passed to `Kernel.get_in()`. Defaults to `[\"status\", \"observedGeneration\"]`.\n\n## Usage\n\n    step Bonny.Pluggable.SkipObservedGenerations,\n      actions: [:add, :modify, :reconcile],\n      observed_generation_key: ~w(status internal observedGeneration)","ref":"Bonny.Pluggable.SkipObservedGenerations.html#module-options"},{"type":"module","title":"Bonny.Resource","doc":"Helper functions for dealing with kubernetes resources.","ref":"Bonny.Resource.html"},{"type":"function","title":"Bonny.Resource.add_owner_reference/3","doc":"Add an owner reference to the given resource.\n\n### Example\n\n    iex> owner = %{\n    ...>   \"apiVersion\" => \"example.com/v1\",\n    ...>   \"kind\" => \"Orange\",\n    ...>   \"metadata\" => %{\n    ...>     \"name\" => \"annoying\",\n    ...>     \"namespace\" => \"default\",\n    ...>     \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n    ...>   }\n    ...> }\n    ...> resource = %{\n    ...>   \"apiVersion\" => \"v1\",\n    ...>   \"kind\" => \"Pod\",\n    ...>   \"metadata\" => %{\"name\" => \"nginx\", \"namespace\" => \"default\"}\n    ...>   # spec\n    ...> }\n    ...> Bonny.Resource.add_owner_reference(resource, owner)\n    %{\n      \"apiVersion\" => \"v1\",\n      \"kind\" => \"Pod\",\n      \"metadata\" => %{\n        \"name\" => \"nginx\",\n        \"namespace\" => \"default\",\n        \"ownerReferences\" => [%{\n          \"apiVersion\" => \"example.com/v1\",\n          \"blockOwnerDeletion\" => false,\n          \"controller\" => true,\n          \"kind\" => \"Orange\",\n          \"name\" => \"annoying\",\n          \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n        }]\n      }\n    }","ref":"Bonny.Resource.html#add_owner_reference/3"},{"type":"function","title":"Bonny.Resource.apply/3","doc":"Applies the given resource to the cluster.","ref":"Bonny.Resource.html#apply/3"},{"type":"function","title":"Bonny.Resource.apply_async/3","doc":"Applies the given resource to the cluster.","ref":"Bonny.Resource.html#apply_async/3"},{"type":"function","title":"Bonny.Resource.apply_status/3","doc":"Applies the status subresource of the given resource to the cluster.\nIf the given resource doesn't contain a status object, nothing is done and\n:noop is returned.","ref":"Bonny.Resource.html#apply_status/3"},{"type":"function","title":"Bonny.Resource.drop_managed_fields/1","doc":"Removes .metadata.managedFields from the resource.","ref":"Bonny.Resource.html#drop_managed_fields/1"},{"type":"function","title":"Bonny.Resource.drop_rv/1","doc":"Removes .metadata.resourceVersion from the resource.","ref":"Bonny.Resource.html#drop_rv/1"},{"type":"function","title":"Bonny.Resource.gvkn/1","doc":"Returns a tuple in the form\n\n* {apiVersion, kind, namespace/name} for namespaced resources\n* {apiVersion, kind, name} for cluster scoped resources","ref":"Bonny.Resource.html#gvkn/1"},{"type":"function","title":"Bonny.Resource.resource_reference/1","doc":"Get a reference to the given resource\n\n### Example\n\n    iex> resource = %{\n    ...>   \"apiVersion\" => \"example.com/v1\",\n    ...>   \"kind\" => \"Orange\",\n    ...>   \"metadata\" => %{\n    ...>     \"name\" => \"annoying\",\n    ...>     \"namespace\" => \"default\",\n    ...>     \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n    ...>   }\n    ...> }\n    ...> Bonny.Resource.resource_reference(resource)\n    %{\n      \"apiVersion\" => \"example.com/v1\",\n      \"kind\" => \"Orange\",\n      \"name\" => \"annoying\",\n      \"namespace\" => \"default\",\n      \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n    }","ref":"Bonny.Resource.html#resource_reference/1"},{"type":"function","title":"Bonny.Resource.set_label/3","doc":"Set a label on the given resource.\n\n### Example\n\n    iex> resource = %{\n    ...>   \"apiVersion\" => \"v1\",\n    ...>   \"kind\" => \"Pod\",\n    ...>   \"metadata\" => %{\"name\" => \"nginx\", \"namespace\" => \"default\"}\n    ...>   # spec\n    ...> }\n    ...> Bonny.Resource.set_label(resource, \"app.kubernetes.io/managed-by\", \"my-operator\")\n    %{\n      \"apiVersion\" => \"v1\",\n      \"kind\" => \"Pod\",\n      \"metadata\" => %{\n        \"name\" => \"nginx\",\n        \"namespace\" => \"default\",\n        \"labels\" => %{\n          \"app.kubernetes.io/managed-by\" => \"my-operator\"\n        }\n      }\n    }","ref":"Bonny.Resource.html#set_label/3"},{"type":"function","title":"Bonny.Resource.set_observed_generation/1","doc":"Sets .status.observedGeneration to .metadata.generation","ref":"Bonny.Resource.html#set_observed_generation/1"},{"type":"type","title":"Bonny.Resource.t/0","doc":"","ref":"Bonny.Resource.html#t:t/0"},{"type":"module","title":"Bonny.Server.AsyncStreamRunner","doc":"Runs the given stream in a separate process. Prepare your stream and add this Runner to your supervision tree\nin order to control it (e.g. restart after the stream ends).","ref":"Bonny.Server.AsyncStreamRunner.html"},{"type":"module","title":"Example - Bonny.Server.AsyncStreamRunner","doc":"# prepare a stream\n    stream =\n      conn\n      |> K8s.Client.stream(operation)\n      |> Stream.filter(&filter_resources/1)\n      |> Stream.map(&process_stream/1)\n\n    children = [\n      {Bonny.Server.AsyncStreamRunner,\n         name: ReconcileServer,\n         stream: stream,\n         termination_delay: 30_000,\n    ]\n\n    Supervisor.init(children, strategy: :one_for_one)\n\n## Options\n\n  * `:stream` - The (prepared) stream to run\n  * `:name` (optional) - Register this process under the given name.\n  * `:termination_delay` (optional) - After the stream ends, how many\n    milliseconds to wait before the process terminates (and might be\n    restarted by the Supervisor). Per default there's no delay","ref":"Bonny.Server.AsyncStreamRunner.html#module-example"},{"type":"function","title":"Bonny.Server.AsyncStreamRunner.child_spec/1","doc":"","ref":"Bonny.Server.AsyncStreamRunner.html#child_spec/1"},{"type":"function","title":"Bonny.Server.AsyncStreamRunner.run/2","doc":"","ref":"Bonny.Server.AsyncStreamRunner.html#run/2"},{"type":"function","title":"Bonny.Server.AsyncStreamRunner.start_link/1","doc":"","ref":"Bonny.Server.AsyncStreamRunner.html#start_link/1"},{"type":"behaviour","title":"Bonny.Server.Reconciler","doc":"Creates a stream that, when run, streams a list of resources and calls `reconcile/1`\non the given controller for each resource in the stream in parallel.","ref":"Bonny.Server.Reconciler.html"},{"type":"behaviour","title":"Example - Bonny.Server.Reconciler","doc":"reconciliation_stream = Bonny.Server.Reconciler.get_stream(controller)\n    Task.async(fn -> Stream.run(reconciliation_stream) end)","ref":"Bonny.Server.Reconciler.html#module-example"},{"type":"function","title":"Bonny.Server.Reconciler.get_raw_stream/3","doc":"","ref":"Bonny.Server.Reconciler.html#get_raw_stream/3"},{"type":"function","title":"Bonny.Server.Reconciler.get_stream/4","doc":"Prepares a stream wich maps each resoruce returned by the `reconcile_operation` to\na function `reconcile/1` on the given `module`. If given, the stream_opts are passed\nto K8s.Client.stream/3","ref":"Bonny.Server.Reconciler.html#get_stream/4"},{"type":"callback","title":"Bonny.Server.Reconciler.reconcile/1","doc":"","ref":"Bonny.Server.Reconciler.html#c:reconcile/1"},{"type":"behaviour","title":"Bonny.Server.Scheduler","doc":"Kubernetes custom scheduler interface. Built on top of `Reconciler`.\n\nThe only function that needs to be implemented is `select_node_for_pod/2`. All others defined by behaviour have default implementations.","ref":"Bonny.Server.Scheduler.html"},{"type":"behaviour","title":"Examples - Bonny.Server.Scheduler","doc":"Will schedule each unschedule pod with `spec.schedulerName=cheap-node` to a node with a label `cheap=true`.\n  `nodes` is a stream that can be lazily filtered:\n\n    defmodule CheapNodeScheduler do\n      use Bonny.Server.Scheduler, name: \"cheap-node\"\n\n      @impl Bonny.Server.Scheduler\n      def select_node_for_pod(_pod, nodes) do\n        nodes\n        |> Stream.filter(fn(node) ->\n          is_cheap = K8s.Resource.label(node, \"cheap\")\n          is_cheap == \"true\"\n        end)\n        |> Enum.take(1)\n        |> List.first\n      end\n    end\n\n    CheapNodeScheduler.start_link()\n\n  Will schedule each unschedule pod with `spec.schedulerName=random-node` to a random node:\n\n    defmodule RandomNodeScheduler do\n      use Bonny.Server.Scheduler, name: \"random-node\"\n\n      @impl Bonny.Server.Scheduler\n      def select_node_for_pod(_pod, nodes) do\n        Enum.random(nodes)\n      end\n    end\n\n    RandomNodeScheduler.start_link()\n\n  Override `nodes/0` default implementation (`pods/0` can be overridden too).\n  Schedules pod on a random GPU node:\n\n    defmodule GpuScheduler do\n      use Bonny.Server.Scheduler, name: \"gpu-node\"\n\n      @impl Bonny.Server.Scheduler\n      def select_node_for_pod(_pod, nodes) do\n        Enum.random(nodes)\n      end\n\n      @impl Bonny.Server.Scheduler\n      def nodes() do\n        label = \"my.label.on.gpu.instances\"\n        conn = Bonny.Config.conn()\n\n        op = K8s.Client.list(\"v1\", :nodes)\n        K8s.Client.stream(conn, op, params: %{labelSelector: label})\n      end\n    end\n\n    GpuScheduler.start_link()","ref":"Bonny.Server.Scheduler.html#module-examples"},{"type":"function","title":"Bonny.Server.Scheduler.bind/3","doc":"Binds a pod to a node","ref":"Bonny.Server.Scheduler.html#bind/3"},{"type":"callback","title":"Bonny.Server.Scheduler.conn/0","doc":"","ref":"Bonny.Server.Scheduler.html#c:conn/0"},{"type":"callback","title":"Bonny.Server.Scheduler.field_selector/0","doc":"Field selector for selecting unscheduled pods waiting to be scheduled by this scheduler.\n\nDefault implementation is all unscheduled pods assigned to this scheduler.","ref":"Bonny.Server.Scheduler.html#c:field_selector/0"},{"type":"function","title":"Bonny.Server.Scheduler.field_selector/1","doc":"Kubernetes API `fieldSelector` value for unbound pods waiting on the given scheduler.","ref":"Bonny.Server.Scheduler.html#field_selector/1"},{"type":"callback","title":"Bonny.Server.Scheduler.name/0","doc":"Name of the scheduler.","ref":"Bonny.Server.Scheduler.html#c:name/0"},{"type":"function","title":"Bonny.Server.Scheduler.nodes/1","doc":"Returns a list of all nodes in the cluster.","ref":"Bonny.Server.Scheduler.html#nodes/1"},{"type":"callback","title":"Bonny.Server.Scheduler.nodes/1","doc":"List of nodes available to this scheduler.\n\nDefault implementation is all nodes in cluster.","ref":"Bonny.Server.Scheduler.html#c:nodes/1"},{"type":"function","title":"Bonny.Server.Scheduler.reconcile/2","doc":"","ref":"Bonny.Server.Scheduler.html#reconcile/2"},{"type":"callback","title":"Bonny.Server.Scheduler.select_node_for_pod/2","doc":"Selects the best node for the current `pod`.\n\nTakes the current unscheduled pod and a `Stream` of nodes. `pod` is provided in the event that `taints` or `affinities` would need to be respected by the scheduler.\n\nReturns the node to schedule on.","ref":"Bonny.Server.Scheduler.html#c:select_node_for_pod/2"},{"type":"module","title":"Bonny.Server.Scheduler.Binding","doc":"Kubernetes [binding](#placeholder) interface.\n\nCurrently [undocumented](https://github.com/kubernetes/kubernetes/issues/75749) in Kubernetes docs.","ref":"Bonny.Server.Scheduler.Binding.html"},{"type":"module","title":"Links - Bonny.Server.Scheduler.Binding","doc":"* [Example using curl](https://gist.github.com/kelseyhightower/2349c9c645d32a3fcbe385082de74668)\n* [Example using golang](https://banzaicloud.com/blog/k8s-custom-scheduler/)","ref":"Bonny.Server.Scheduler.Binding.html#module-links"},{"type":"function","title":"Bonny.Server.Scheduler.Binding.create/3","doc":"Creates the pod's /binding subresource through K8s.","ref":"Bonny.Server.Scheduler.Binding.html#create/3"},{"type":"function","title":"Bonny.Server.Scheduler.Binding.new/2","doc":"Returns a map representing a `Binding` kubernetes resource","ref":"Bonny.Server.Scheduler.Binding.html#new/2"},{"type":"function","title":"Example - Bonny.Server.Scheduler.Binding.new/2","doc":"iex> pod = %{\"metadata\" => %{\"name\" => \"nginx\", \"namespace\" => \"default\"}}\n    ...> node = %{\"metadata\" => %{\"name\" => \"kewl-node\"}}\n    iex> Bonny.Server.Scheduler.Binding.new(pod, node)\n    %{\"apiVersion\" => \"v1\", \"kind\" => \"Binding\", \"metadata\" => %{\"name\" => \"nginx\", \"namespace\" => \"default\"}, \"target\" => %{\"apiVersion\" => \"v1\", \"kind\" => \"Node\", \"name\" => \"kewl-node\"}}","ref":"Bonny.Server.Scheduler.Binding.html#new/2-example"},{"type":"module","title":"Bonny.Server.Watcher","doc":"Creates the stream for watching resources in kubernetes and prepares its processing.\n\nWatching a resource in kubernetes results in a stream of add/modify/delete events.\nThis module uses `K8s.Client.stream/3` to create such a stream and maps\nevents to a controller's event handler. It is then up to the caller to run the\nresulting stream.","ref":"Bonny.Server.Watcher.html"},{"type":"module","title":"Example - Bonny.Server.Watcher","doc":"watch_stream = Bonny.Server.Watcher.get_stream(controller)\n    Task.async(fn -> Stream.run(watch_stream) end)","ref":"Bonny.Server.Watcher.html#module-example"},{"type":"function","title":"Bonny.Server.Watcher.get_raw_stream/2","doc":"","ref":"Bonny.Server.Watcher.html#get_raw_stream/2"},{"type":"function","title":"Bonny.Server.Watcher.get_stream/3","doc":"","ref":"Bonny.Server.Watcher.html#get_stream/3"},{"type":"type","title":"Bonny.Server.Watcher.action/0","doc":"","ref":"Bonny.Server.Watcher.html#t:action/0"},{"type":"type","title":"Bonny.Server.Watcher.watch_event/0","doc":"","ref":"Bonny.Server.Watcher.html#t:watch_event/0"},{"type":"module","title":"Bonny.Sys.Event","doc":"Telemetry event definitions for this library","ref":"Bonny.Sys.Event.html"},{"type":"function","title":"Bonny.Sys.Event.events/0","doc":"","ref":"Bonny.Sys.Event.html#events/0"},{"type":"module","title":"Bonny.Sys.Logger","doc":"Attaches telemetry events to the Elixir Logger","ref":"Bonny.Sys.Logger.html"},{"type":"function","title":"Bonny.Sys.Logger.attach/0","doc":"Attaches telemetry events to the Elixir Logger","ref":"Bonny.Sys.Logger.html#attach/0"},{"type":"module","title":"Bonny.Sys.Telemetry","doc":"Telemetry event definitions for this library","ref":"Bonny.Sys.Telemetry.html"},{"type":"function","title":"Bonny.Sys.Telemetry.events/0","doc":"","ref":"Bonny.Sys.Telemetry.html#events/0"},{"type":"module","title":"DeploymentEventLogController","doc":"This is a goofy config, but it makes this work in dev w/o having to POST an Example CRD.\n\nThis controller simply logs lifecycle events on Deployments.","ref":"DeploymentEventLogController.html"},{"type":"function","title":"DeploymentEventLogController.handle_event/2","doc":"","ref":"DeploymentEventLogController.html#handle_event/2"},{"type":"function","title":"DeploymentEventLogController.rbac_rules/0","doc":"","ref":"DeploymentEventLogController.html#rbac_rules/0"},{"type":"function","title":"DeploymentEventLogController.track_event/2","doc":"","ref":"DeploymentEventLogController.html#track_event/2"},{"type":"module","title":"Mix.Bonny","doc":"Mix task helpers","ref":"Mix.Bonny.html"},{"type":"function","title":"Mix.Bonny.add_or_create_with/5","doc":"","ref":"Mix.Bonny.html#add_or_create_with/5"},{"type":"function","title":"Mix.Bonny.app_dir_name/0","doc":"","ref":"Mix.Bonny.html#app_dir_name/0"},{"type":"function","title":"Mix.Bonny.app_name/0","doc":"Get the OTP app name","ref":"Mix.Bonny.html#app_name/0"},{"type":"function","title":"Mix.Bonny.append_or_create_with/4","doc":"Appends `append_content` to `target`. If `target` does not exist, a new\nfile with `new_file_content` is created.","ref":"Mix.Bonny.html#append_or_create_with/4"},{"type":"function","title":"Mix.Bonny.copy/2","doc":"","ref":"Mix.Bonny.html#copy/2"},{"type":"function","title":"Mix.Bonny.ensure_module_name/1","doc":"Capitalizes the string if it does not begin with a capital letter.","ref":"Mix.Bonny.html#ensure_module_name/1"},{"type":"function","title":"Mix.Bonny.error/1","doc":"","ref":"Mix.Bonny.html#error/1"},{"type":"function","title":"Mix.Bonny.hyphenated_app_name/0","doc":"Get the OTP app name with dashes","ref":"Mix.Bonny.html#hyphenated_app_name/0"},{"type":"function","title":"Mix.Bonny.no_umbrella!/0","doc":"","ref":"Mix.Bonny.html#no_umbrella!/0"},{"type":"function","title":"Mix.Bonny.parse_args/3","doc":"Parse CLI input","ref":"Mix.Bonny.html#parse_args/3"},{"type":"function","title":"Mix.Bonny.prepend_or_create_with/4","doc":"Prepends `append_content` to `target`. If `target` does not exist, a new\nfile with `new_file_content` is created.","ref":"Mix.Bonny.html#prepend_or_create_with/4"},{"type":"function","title":"Mix.Bonny.render/2","doc":"Render text to a file.\n\nSpecial handling for the path \"-\" will render to STDOUT","ref":"Mix.Bonny.html#render/2"},{"type":"function","title":"Mix.Bonny.render_template/3","doc":"","ref":"Mix.Bonny.html#render_template/3"},{"type":"function","title":"Mix.Bonny.template/1","doc":"","ref":"Mix.Bonny.html#template/1"},{"type":"task","title":"mix bonny.gen.controller","doc":"Generates a new CRD controller\n\nAn operator can have multiple controllers. Each controller handles the lifecycle of a custom resource.\n\n```shell\nmix bonny.gen.controller\n```\nOpen up your controller and add functionality for your resources lifecycle:\n\n* Add\n* Modify\n* Delete\n* Reconcile\n\nIf you selected to add a CRD, also edit the generated CRD version module.","ref":"Mix.Tasks.Bonny.Gen.Controller.html"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Controller.get_input/1","doc":"","ref":"Mix.Tasks.Bonny.Gen.Controller.html#get_input/1"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Controller.run/1","doc":"","ref":"Mix.Tasks.Bonny.Gen.Controller.html#run/1"},{"type":"task","title":"mix bonny.gen.dockerfile","doc":"Generates a Dockerfile for this operator","ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Dockerfile.run/1","doc":"","ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html#run/1"},{"type":"task","title":"mix bonny.gen.manifest","doc":"Generates the Kubernetes YAML manifest for this operator\n\nmix bonny.gen.manifest expects a docker image name if deploying to a cluster. You may optionally provide a namespace.","ref":"Mix.Tasks.Bonny.Gen.Manifest.html"},{"type":"task","title":"Examples - mix bonny.gen.manifest","doc":"The `image` switch is required.\n\nOptions:\n* --image (docker image to deploy)\n* --namespace (of service account and deployment; defaults to \"default\")\n* --out (path to save manifest; defaults to \"manifest.yaml\")\n\n*Deploying to kubernetes:*\n\n```shell\n\ndocker build -t $(YOUR_IMAGE_URL) .\ndocker push $(YOUR_IMAGE_URL)\n\nmix bonny.gen.manifest --image $(YOUR_IMAGE_URL):latest --namespace default\nkubectl apply -f manifest.yaml -n default\n```\n\nTo skip the `deployment` for running an operator outside of the cluster (like in development) simply omit the `--image` flag:\n\n```shell\nmix bonny.gen.manifest\n```","ref":"Mix.Tasks.Bonny.Gen.Manifest.html#module-examples"},{"type":"function","title":"Mix.Tasks.Bonny.Gen.Manifest.run/1","doc":"","ref":"Mix.Tasks.Bonny.Gen.Manifest.html#run/1"},{"type":"task","title":"mix bonny.init","doc":"Initialized an operator wiht bonny.\n\n* Initializes application configuration\n* Generates helper files for tests","ref":"Mix.Tasks.Bonny.Init.html"},{"type":"function","title":"Mix.Tasks.Bonny.Init.get_input/1","doc":"","ref":"Mix.Tasks.Bonny.Init.html#get_input/1"},{"type":"function","title":"Mix.Tasks.Bonny.Init.run/1","doc":"","ref":"Mix.Tasks.Bonny.Init.html#run/1"},{"type":"module","title":"TestScheduler","doc":"","ref":"TestScheduler.html"},{"type":"function","title":"TestScheduler.child_spec/1","doc":"","ref":"TestScheduler.html#child_spec/1"},{"type":"function","title":"TestScheduler.conn/0","doc":"","ref":"TestScheduler.html#conn/0"},{"type":"function","title":"TestScheduler.field_selector/0","doc":"Kubernetes HTTP API `fieldSelector`.","ref":"TestScheduler.html#field_selector/0"},{"type":"function","title":"TestScheduler.name/0","doc":"Scheduler name","ref":"TestScheduler.html#name/0"},{"type":"function","title":"TestScheduler.nodes/1","doc":"List of nodes available to this scheduler.","ref":"TestScheduler.html#nodes/1"},{"type":"function","title":"TestScheduler.select_node_for_pod/2","doc":"","ref":"TestScheduler.html#select_node_for_pod/2"},{"type":"exception","title":"Bonny.Axn.DescendantsAlreadyAppliedError","doc":"Error raised when trying to register a descendant or apply the descendants\nwhen already applied.","ref":"Bonny.Axn.DescendantsAlreadyAppliedError.html"},{"type":"exception","title":"Bonny.Axn.EventsAlreadyEmittedError","doc":"Error raised when trying to register an event or emit evnts when already\nemitted.","ref":"Bonny.Axn.EventsAlreadyEmittedError.html"},{"type":"exception","title":"Bonny.Axn.StatusAlreadyAppliedError","doc":"Error raised when trying to update or apply an already applied status","ref":"Bonny.Axn.StatusAlreadyAppliedError.html"},{"type":"extras","title":"README","doc":"![Bonny](./assets/banner.png \"Bonny\")\n\n[![Module Version](https://img.shields.io/hexpm/v/bonny.svg)](https://hex.pm/packages/bonny)\n[![Coverage Status](https://coveralls.io/repos/github/coryodaniel/bonny/badge.svg?branch=master)](https://coveralls.io/github/coryodaniel/bonny?branch=master)\n[![Last Updated](https://img.shields.io/github/last-commit/coryodaniel/bonny.svg)](https://github.com/coryodaniel/bonny/commits/master)\n\n[![Build Status CI](https://github.com/coryodaniel/bonny/actions/workflows/ci.yaml/badge.svg)](https://github.com/coryodaniel/bonny/actions/workflows/ci.yaml)\n[![Build Status Elixir](https://github.com/coryodaniel/bonny/actions/workflows/elixir_matrix.yaml/badge.svg)](https://github.com/coryodaniel/bonny/actions/workflows/elixir_matrix.yaml)\n[![Build Status K8s](https://github.com/coryodaniel/bonny/actions/workflows/k8s_matrix.yaml/badge.svg)](https://github.com/coryodaniel/bonny/actions/workflows/k8s_matrix.yaml)\n\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/bonny/)\n[![Total Download](https://img.shields.io/hexpm/dt/bonny.svg)](https://hex.pm/packages/bonny)\n[![License](https://img.shields.io/hexpm/l/bonny.svg)](https://github.com/coryodaniel/bonny/blob/master/LICENSE)\n\n# Bonny: Kubernetes Development Framework\n\nExtend the Kubernetes API with Elixir.\n\nBonny make it easy to create Kubernetes Operators, Controllers, and Custom [Schedulers](./lib/bonny/server/scheduler.ex).\n\nIf Kubernetes CRDs and controllers are new to you, read up on the [terminology](#terminology).","ref":"readme.html"},{"type":"extras","title":"Getting Started - README","doc":"Kickstarting your first controller with bonny is very straight-forward. Bonny\ncomes with some handy mix tasks to help you.\n\n```\nmix new your_operator\n```\n\nNow add bonny to your dependencies in `mix.exs`\n\n```elixir\ndef deps do\n  [\n    {:bonny, \"~> 1.0\"}\n  ]\nend\n```\n\nInstall dependencies and initialize bonny. This task will ask you\nto answer a few questions about your operator.\n\nRefer to the [kubernetes docs](https://kubernetes.io/docs/concepts/overview/kubernetes-api/#api-groups-and-versioning) for\nAPI group and API version.\n\n```\nmix deps.get\nmix bonny.init\n```\n\n**Don't forget to add the generated operator module to your application supervisor.**\n\n#","ref":"readme.html#getting-started"},{"type":"extras","title":"Configuration - README","doc":"`mix bonny.init` creates a configuration file `config/bonny.exs` and imports it to `config/config.exs` for you.\n\n##","ref":"readme.html#configuration"},{"type":"extras","title":"Configuring Bonny - README","doc":"Configuring bonny is necessary for the manifest generation through `mix bonny.gen.manifest`.\n\n```elixir\n\nconfig :bonny,\n  # Function to call to get a K8s.Conn object.\n  # The function should return a %K8s.Conn{} struct or a {:ok, %K8s.Conn{}} tuple\n  get_conn: {K8s.Conn, :from_file, [\"~/.kube/config\", [context: \"docker-for-desktop\"]]},\n\n  # Set the Kubernetes API group for this operator.\n  # This can be overwritten using the @group attribute of a controller\n  group: \"your-operator.example.com\",\n\n  # Name must only consist of only lowercase letters and hyphens.\n  # Defaults to hyphenated mix app name\n  operator_name: \"your-operator\",\n\n  # Name must only consist of only lowercase letters and hyphens.\n  # Defaults to hyphenated mix app name\n  service_account_name: \"your-operator\",\n\n  # Labels to apply to the operator's resources.\n  labels: %{\n    \"kewl\": \"true\"\n  },\n\n  # Operator deployment resources. These are the defaults.\n  resources: %{\n    limits: %{cpu: \"200m\", memory: \"200Mi\"},\n    requests: %{cpu: \"200m\", memory: \"200Mi\"}\n  }\n```","ref":"readme.html#configuring-bonny"},{"type":"extras","title":"Running outside of a cluster - README","doc":"Running an operator outside of Kubernetes is not recommended for production use, but can be very useful when testing.\n\nTo start your operator and connect it to an existing cluster, one must first:\n\n1. Have configured your operator. The above example is a good place to start.\n2. Have some way of connecting to your cluster. The most common is to connect using your kubeconfig as in the example:\n\n```elixir\n# config.exs\nconfig :bonny,\n  get_conn: {K8s.Conn, :from_file, [\"~/.kube/config\", [context: \"optional-alternate-context\"]]}\n```\n\nIf you've used `mix bonny.init` to generate your config, it created a `YourOperator.Conn` module for you. You can edit that instead.\n\n3. If RBAC is enabled, you must have permissions for creating and modifying `CustomResourceDefinition`, `ClusterRole`, `ClusterRoleBinding` and `ServiceAccount`.\n4. Generate a manifest `mix bonny.gen.manifest` and install it using kubectl `kubectl apply -f manifest.yaml`\n\nNow you are ready to run your operator\n\n```shell\niex -S mix\n```","ref":"readme.html#running-outside-of-a-cluster"},{"type":"extras","title":"Guides - README","doc":"Have a look at the guides that come with this repository. Some can even be opened as a livebook.\n\n- [Mix Tasks](guides/mix_tasks.md)\n- [The Operator](guides/the_operator.livemd)\n- [Controllers](guides/controllers.livemd)\n- [Testing Controllers](guides/testing.livemd)\n- [CRD Versions](guides/crd_versions.livemd)\n- [Migrations](guides/migrations.md)\n- [Contributing](guides/contributing.md)","ref":"readme.html#guides"},{"type":"extras","title":"Talks - README","doc":"- Commandeering Kubernetes @ The Big Elixir 2019\n  - [slides](https://speakerdeck.com/coryodaniel/commandeering-kubernetes-with-elixir)\n  - [source code](https://github.com/coryodaniel/talks/tree/master/commandeering)\n  - [video](https://www.youtube.com/watch?v=0r9YmbH0xTY)","ref":"readme.html#talks"},{"type":"extras","title":"Example Operators built with this version of Bonny - README","doc":"- [Kompost](https://github.com/mruoss/kompost) - Providing self-service management of resources for devs","ref":"readme.html#example-operators-built-with-this-version-of-bonny"},{"type":"extras","title":"Example Operators built with an older version of Bonny - README","doc":"- [Eviction Operator](https://github.com/bonny-k8s/eviction_operator) - Bonny v 0.4\n- [Hello Operator](https://github.com/coryodaniel/hello_operator) - Bonny v 0.4\n- [Todo Operator](https://github.com/bonny-k8s/todo-operator) - Bonny v 0.4","ref":"readme.html#example-operators-built-with-an-older-version-of-bonny"},{"type":"extras","title":"Telemetry - README","doc":"Bonny uses the `telemetry` to emit event metrics.\n\nEvents: `Bonny.Sys.Telemetry.events()`\n\n```elixir\n[\n    [:reconciler, :reconcile, :start],\n    [:reconciler, :reconcile, :stop],\n    [:reconciler, :reconcile, :exception],\n    [:watcher, :watch, :start],\n    [:watcher, :watch, :stop],\n    [:watcher, :watch, :exception],\n    [:scheduler, :binding, :start],\n    [:scheduler, :binding, :stop],\n    [:scheduler, :binding, :exception],\n    [:task, :execution, :start],\n    [:task, :execution, :stop],\n    [:task, :execution, :exception],\n]\n```","ref":"readme.html#telemetry"},{"type":"extras","title":"Terminology - README","doc":"_[Custom Resource](https://kubernetes.io/docs/concepts/extend-kubernetes/api-extension/custom-resources/#custom-resources)_:\n\n> A custom resource is an extension of the Kubernetes API that is not necessarily available on every Kubernetes cluster. In other words, it represents a customization of a particular Kubernetes installation.\n\n_[CRD Custom Resource Definition](https://kubernetes.io/docs/concepts/extend-kubernetes/api-extension/custom-resources/#customresourcedefinitions)_:\n\n> The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource.\n\n_[Controller](https://kubernetes.io/docs/concepts/extend-kubernetes/api-extension/custom-resources/#custom-controllers)_:\n\n> A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API.\n\n_[Operator](https://kubernetes.io/docs/concepts/extend-kubernetes/operator/)_:\n\nA set of application specific controllers deployed on Kubernetes and managed via kubectl and the Kubernetes API.","ref":"readme.html#terminology"},{"type":"extras","title":"Contributing - README","doc":"I'm thankful for any contribution to this project. Check out the [contribution guide](guides/contributing.md)","ref":"readme.html#contributing"},{"type":"extras","title":"Operator Blog Posts - README","doc":"- [Why Kubernetes Operators are a game changer](https://blog.couchbase.com/kubernetes-operators-game-changer/)","ref":"readme.html#operator-blog-posts"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"Unreleased - Changelog","doc":"<!-- #","ref":"changelog.html#unreleased"},{"type":"extras","title":"Added | Changed | Deprecated | Removed | Fixed | Security --> - Changelog","doc":"## [1.4.0] - 2023-11-04\n\n#","ref":"changelog.html#added-changed-deprecated-removed-fixed-security"},{"type":"extras","title":"Added - Changelog","doc":"- Added telemetry events to the Operator module - [#244](https://github.com/coryodaniel/bonny/pull/244)\n\n## [1.3.0] - 2023-09-25\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- `Bonny.Axn.register_descendant/3` - Add option `group` to define in what group to apply a descendant and apply descendants in groups.\n\n## [1.2.1] - 2023-06-26\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- BONNY_OPERATOR_NAME env var is not a reference\n\n## [1.2.0] - 2023-06-13\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Start leader election by default - [#195](https://github.com/coryodaniel/bonny/pull/195)\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- `mix bonny.gen.manifest` - Merge RBAC rules for the same resources - [#213](https://github.com/coryodaniel/bonny/pull/213)\n- Compile time dependency at runtime - [#212](https://github.com/coryodaniel/bonny/pull/212)\n\n## [1.1.3] - 2023-04-09\n\n- Leader Election: Add missing RBAC permission to access leases - [#207](https://github.com/coryodaniel/bonny/pull/207)\n\n## [1.1.2] - 2023-03-07\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Simple leader election for running multiple replicas (BETA) - [#195](https://github.com/coryodaniel/bonny/pull/195)\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix for an issue reported in [#180](https://github.com/coryodaniel/bonny/pull/180) already: Add operator name as env variable to deployment.\n\n#","ref":"changelog.html#fixes"},{"type":"extras","title":"Chores - Changelog","doc":"- Upgrade k8s to 2.1.1\n\n## [1.1.1] - 2023-02-24\n\n#","ref":"changelog.html#chores"},{"type":"extras","title":"Fixed - Changelog","doc":"- `Bonny.Pluggable.Finalizer` - Remove finalizers from resource if they need to be removed.\n- `Bonny.Axn` - Regression where descendants were not applied - [#192](https://github.com/coryodaniel/bonny/pull/192), [#191](https://github.com/coryodaniel/bonny/issues/191)\n\n## [1.1.0] - 2023-02-22\n\nThis release updates its dependency on `k8s` to a new major version (`2.x`). If\nyou're using `k8s` directly in your code, you should have added it explicitely\nto your dependencies in `mix.exs` and this update will fail until you update\nthat dependency manually. If you're using `k8s` directly in your code but you\nhaven't added it explicetly to your list of dependencies, you might get\nsurprises as `2.x` comes with (yet few) breaking changes.\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Prevent duplicate descendants\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Upgraded k8s dependency to 2.x. [#173](https://github.com/coryodaniel/bonny/pull/173)\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- `Bonny.Pluggable.AddMissingGVK` - A pluggable step for adding missing GVK information to resources - [#184](https://github.com/coryodaniel/bonny/pull/184), [#183](https://github.com/coryodaniel/bonny/issues/183)\n- Helpers to define conditions on custom resources. [#188](https://github.com/coryodaniel/bonny/pull/188)\n  - `Bonny.API.Version.add_conditions/1` - Helper to define a schema for conditions on the CRD\n  - `Bonny.Axn.set_condition/4` - Helper to set a condition on a resource\n- `Bonny.Pluggable.Finalizer` - A pluggable step to define and implement finalizers, [#6](https://github.com/coryodaniel/bonny/issues/6), [#189](https://github.com/coryodaniel/bonny/pull/189)\n- `Bonny.Axn.register_after_processed/2` - Registers a callback to be invoked at the very end of an action event's processing by the operator\n\n## [1.0.1] - 2023-02-04\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Initialized application calls the wrong function to initialize conn - [#181](https://github.com/coryodaniel/bonny/pull/181)\n- Don't add operator to supervision tree in `:test` env per default - [#182](https://github.com/coryodaniel/bonny/issues/182)\n\n## [1.0.0] - 2022-11-28\n\nWith Version 1.0.0, Bonny got a thorough refactoring. Besides this changelog,\nyou might consider the several guides (e.g. the [migration guide](./guides/migration.mid))\n\n- `Bonny.Operator` was introduced as an entry point to the watching and handling\n  of processes. Your controllers are not more added to the supervision tree by\n  bonny. Instead you must create an operator and add that to your application's\n  supervision tree.\n- The [`Pluggable`](https://hex.pm/packages/pluggable) (think [`Plug`](https://hex.pm/packages/plug))\n  library is used with `Bonny.Axn` as token to process `ADDED`, `MODIFIED`,\n  `DELETED` and reconciliation events by `Pluggable` pipelines.\n- `Bonny.ControllerV2` was introduced as a successor to `Bonny.Controller`. It leverages\n  `Pluggable.StepBuilder` (think `Plug.Builder`) to build a pluggable pipeline.\n- `Bonny.Event` and `Bonny.EventRecorder` were introducd for Kubernetes\n  event creation ([#156](https://github.com/coryodaniel/bonny/pull/156), [#5](https://github.com/coryodaniel/bonny/issues/5))\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Why this refactoring? - Changelog","doc":"- Allows for better CRD and API version definitions\n- With a `Pluggable` architecture, controllers are much easier to test (Think of `Plug.Conn` tests)\n- The `Pluggable` architecture makes your processing pipelines composable and simpler to customize/extend\n- Decoupling of manifest generation and action event processing\n- Internally, the amount of macros was reduced which makes Bonny easier to understand and maintain\n\n## [1.0.0-rc.3] - 2022-11-19\n\n#","ref":"changelog.html#why-this-refactoring"},{"type":"extras","title":"Fixed - Changelog","doc":"- `Bonny.Mix.Operator` - fix manifest generation: remove version from apiGroup in ClusterRole.\n\n## [1.0.0-rc.2] - 2022-11-15\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- `Bonny.Pluggable.AddManagedByLabelToDescendants` - Adds the `app.kubernetes.io/managed-by` label to all descendants registered within the pipeline.\n- Allow `nil` and `{controller :: module(), init_opts :: keyword()}` in the operator's `controllers/2` callback.\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- `K8sConn` - Implement spec correctly.\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- `Bonny.Axn.apply_descendants/N`, `Bonny.Axn.apply_status/N` - Raise upon error.\n\n## [1.0.0-rc.1] - 2022-10-31\n\n# Added\n\n- Better logs in case of errors while applying status, descendants or events\n- Integration tests for these logs\n\n## [1.0.0-rc.0] - 2022-10-29\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"With Version 1.0.0, Bonny got a thorough refactoring. Besides this changelog,\nyou might consider the several guides (e.g. the [migration guide](./guides/migration.mid))\n\n- `Bonny.Operator` was introduced as an entry point to the watching and handling\n  of processes. Your controllers are not more added to the supervision tree by\n  bonny. Instead you must create an operator and add that to your application's\n  supervision tree.\n- The [`Pluggable`](https://hex.pm/packages/pluggable) (think [`Plug`](https://hex.pm/packages/plug))\n  library is used with `Bonny.Axn` as token to process `ADDED`, `MODIFIED`,\n  `DELETED` and reconciliation events by `Pluggable` pipelines.\n- `Bonny.ControllerV2` was introduced as a successor to `Bonny.Controller`. It leverages\n  `Pluggable.StepBuilder` (think `Plug.Builder`) to build a pluggable pipeline.\n- `Bonny.Event` and `Bonny.EventRecorder` were introducd for Kubernetes\n  event creation ([#156](https://github.com/coryodaniel/bonny/pull/156), [#5](https://github.com/coryodaniel/bonny/issues/5))\n\nWhy this refactoring?\n\n- Allows for better CRD and API version definitions\n- With a `Pluggable` architecture, controllers are much easier to test (Think of `Plug.Conn` tests)\n- The `Pluggable` architecture makes your processing pipelines composable and simpler to customize/extend\n- Manifest generation and event processing were decoupled\n- Internally, the amount of macros was reduced which makes Bonny easier to maintain\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- `Bonny.Pluggable.SkipObservedGenerations` - halts the pipelines for a defined list of actions if the observed generation equals the resource's generation.\n- `Bonny.Pluggable.ApplyDescendants` - applies all the descendants added to the `%Bonny.Axn{}` struct.\n- `Bonny.Pluggable.ApplyStatus` - applies the status of the given `%Bonny.Axn{}` struct to the status subresource.\n- `Bonny.Pluggable.Logger`- logs an action event and when status, descendants and events are applied to the cluster. If desired, it makes sense to be placed as first step in your operator pipeline but can also be added to a controller pipeline.\n- `Bonny.Resource.add_owner_reference/3` used to add the owner reference to resources created by the controller. ([#147](https://github.com/coryodaniel/bonny/pull/147))\n- An integration test suite was added that runs tests against a \"real\" kubernetes cluster on the CI pipeline ([#146](https://github.com/coryodaniel/bonny/pull/146), [#84](https://github.com/coryodaniel/bonny/issues/84))\n- Mix task for initializing a new operator `mix bonny.init` ([#160](https://github.com/coryodaniel/bonny/pull/160), [#67](https://github.com/coryodaniel/bonny/issues/67))\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Deprecated - Changelog","doc":"- `Bonny.Controller` was deprecated in favor of the new design with\n  `Bonny.Operator` and `Bonny.ControllerV2`\n\n## [0.5.2] - 2022-08-31\n\n#","ref":"changelog.html#deprecated"},{"type":"extras","title":"Updated - Changelog","doc":"- Use name of application in Deployments instead of service account name. ([#142](https://github.com/coryodaniel/bonny/pull/142))\n\n#","ref":"changelog.html#updated"},{"type":"extras","title":"Fixed - Changelog","doc":"- CRD manifest generation for `apiextensions.k8s.io/v1` ([#143](https://github.com/coryodaniel/bonny/pull/143), [#117](https://github.com/coryodaniel/bonny/issues/117), [#101](https://github.com/coryodaniel/bonny/pull/101))\n\n## [0.5.1] - 2022-05-25\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Add missing `priv` folder to package\n\n## [0.5.0] - 2022-04-23\n\nVersion 0.5.0 comes with some major changes. Please read through the [migration guide](./guides/migrations.md) before upgrading.","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- `Bonny.Server.AsyncStreamRunner` to run streams in a separate process\n- `Bonny.Sys.Telemetry` defines `telemetry` spans and events","ref":"changelog.html#added"},{"type":"extras","title":"Updated - Changelog","doc":"- `Bonny.Server.Watcher` and `Bonny.Server.Reconciler` were rewritten completely. They now prepare streams which are to be run with `Bonny.Server.AsyncStreamRunner`\n- Dependency `k8s` was updated to version `~> 1.1` and code was refactored accordingly","ref":"changelog.html#updated"},{"type":"extras","title":"Deprecated - Changelog","doc":"- `Bonny.Sys.Event` was deprecated in favor of `Bonny.Sys.Telemetry`\n\n## [0.4.4] - 2021-08-09\n\n#","ref":"changelog.html#deprecated"},{"type":"extras","title":"Added - Changelog","doc":"- @impl to macros for clean compilation\n- error handling for mid-stream errors\n\n## [0.4.3] - 2020-06-09\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Configure watched namespace via config.exs or BONNY_POD_NAMESPACE\n- BONNY_POD_NAMESPACE supports \"magic\" value \"**ALL**\"\n\n## [0.4.1] - 2019-11-26\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Support for reconciling/watching `core` resources\n\n## [0.4.0] - 2019-10-23\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Basic integration w/ [Notion](https://github.com/coryodaniel/notion) for telemetry\n- Bonny.Server.Reconciler continually process a list operation\n- Bonny.Server.Scheduler write custom kubernetes schedulers\n- Added Bonny.PeriodicTask for scheduling periodically executed functions\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Dockerfile gen uses OTP releases\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- Removed `reconcile_batch_size`\n\n## [0.3.3] - 2019-06-25\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- Add additional printer columns\n- Bonny.Naming module\n- .credo.exs\n\n## [0.3.2] - 2019-04-15\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Bonny.Watcher and Bonny.Reconciler telemetry events\n\n## [0.3.1] - 2019-04-11\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Support for a reconcile/1 callback\n- `reconcile_every` config option to schedule how often to run\n  reconciliation\n- `reconcile_batch_size` to set the size of the HTTP GET limit\n  when fetching batches of items to reconcile\n- Added `{:error, binary}` as a return value of Controller lifecycle methods\n- Implemented `:telemetry` library\n- `Bonny.Sys.Event.events/0` exposes list of telemetry events\n- `mix bonny.gen.manifest --local` for building manifests w/o a Deployment for\n  local testing\n- `cluster_name: :default` config options. Now uses [k8s](https://github.com/coryodaniel/k8s) cluster registration configuration.\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Async watcher event dispatch\n- Replaced `HTTPoison` with [k8s](https://github.com/coryodaniel/k8s)\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Receiving :DOWN messages no longer crashes Watcher [#20](https://github.com/coryodaniel/bonny/issues/20)\n- Issue with partially received events [#43](https://github.com/coryodaniel/bonny/issues/43)\n- Fix invalid singular name generation from module names \"MyMod\" -> my_mod; \"MyMod\" -> mymod\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Removed - Changelog","doc":"- Renamed `group_version` -> `api_version`\n- Renamed Bonny.CRD.plural/1 -> `Bonny.CRD.kind/1`\n- `Bypass` from test suite\n- `Impl.parse_metadata/1`\n- `kubeconf_file` and `kubeconf_opts` config options\n\n## [0.3.0] - 2019-03-04\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Changed - Changelog","doc":"- Replaced `k8s_conf` library with [k8s](https://github.com/coryodaniel/k8s).\n\n## [0.2.3] - 2019-01-13\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Initial public release.\n- Controller lifecycle implementation.\n- CRD Watcher.\n- mix task: controller generator\n- mix task: dockerfile generator\n- mix task: k8s manifest generator","ref":"changelog.html#added"},{"type":"extras","title":"Controllers","doc":"# Controllers\n\n```elixir\nMix.install([:kino, :bonny])\n\nApplication.put_env(:bonny, :operator_name, \"livebook\")\n```","ref":"controllers.html"},{"type":"extras","title":"Creating your first Controller - Controllers","doc":"When running `mix bonny.init`, the task asks you to define CRDs and controllers already. It is optional but I advise to do so as it initializes your operator then. To create additional controllers, run `mix bonny.gen.controller`.\n\n`mix bonny.gen.controller` does not register the controller with your operator. (Note however, that `mix bonny.init`does!) In order for your controller to do something, you need to add an entry to the `controllers/2` callback in your operator. See the operators guide for more information about operators.","ref":"controllers.html#creating-your-first-controller"},{"type":"extras","title":"Action Event Handlers - Controllers","doc":"A controller is a [`Pluggable`](https://hex.pm/packages/pluggable) step and uses `Pluggable.StepBuilder` underneath. When an action event is dispatched, the controller is called and all its steps are executed.Your task is to add steps to the controller which process the action event.\n\nIf you used `mix bonny.gen.controller` to create the controller, a `handle_event/2` step and its implementation are added to your controller by the script. Besides that, `mix bonny.gen.controller` also adds steps for skipping observed generations. See the section about [skipping observed generations](#skipping-observed-generations) for more information on those.\n\n```elixir\ndefmodule AppleController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n\n  # apply the resource\n  def handle_event(%Bonny.Axn{action: action} = axn, _opts)\n      when action in [:add, :modify, :reconcile] do\n    IO.inspect(axn.resource)\n    success_event(axn)\n  end\n\n  # delete the resource\n  def handle_event(%Bonny.Axn{action: :delete} = axn, _opts) do\n    IO.inspect(axn.resource)\n    axn\n  end\nend\n```\n\nThe step s you implement are called with a `%Bonny.Axn{}` token. It contains the `action` which triggered this event, the `resource` the event regards and other fields. Use pattern matching or a adispatch mechanism to handle the four different action types:\n\n- `add/1` - resource was created in the cluster.\n- `delete/1` - resource was deleted from the cluster.\n- `modify/1` - resource was modified in the cluster.\n- `reconcile/1` - Called on a regular basis in case we missed an action or to fix diverged state.\n\nYour event handlers should return the struct it received as first parameter. However, your controller can use helper functions from the `Bonny.Axn` module to modify it before returning it.","ref":"controllers.html#action-event-handlers"},{"type":"extras","title":"Descendant Resources - Controllers","doc":"Your controller might create descendant resources for its custom resource. For example, a `MyAppController` would create deployments and services for a `MyApp` resource.\n\nUse `Bonny.Axn.register_descendant/3` to add such descendants. Descendants are not directly applied to the cluster. They are only registered within the `%Bonny.Axn{}` token. **Note that you need to add step `Bonny.Pluggable.ApplyDescendants` to either your controller or operator in order to apply descendants to the cluster.**\n\n#","ref":"controllers.html#descendant-resources"},{"type":"extras","title":"Owner Reference - Controllers","doc":"If your controller creates descendant resources for your custom resource, it is good practice to reference the owner(s). In kubernetes, you do this by adding an entry to `.metadata.ownerReferences`. `Bonny.Axn.register_descendant/3` does that for you unless you pass `ommit_owner_ref: true` as option.\n\n \n\n```elixir\ndefmodule MyAppController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n\n  # apply the resource\n  def handle_event(%Bonny.Axn{action: action} = axn, _opts)\n      when action in [:add, :modify, :reconcile] do\n    depl = %{\n      \"apiVersion\" => \"apps/v1\",\n      \"kind\" => \"Deployment\",\n      \"metadata\" => %{\"namespace\" => \"default\", \"name\" => axn.resource[\"metadata\"][\"name\"]}\n      # spec\n    }\n\n    svc = %{\n      \"apiVersion\" => \"v1\",\n      \"kind\" => \"Service\",\n      \"metadata\" => %{\"namespace\" => \"default\", \"name\" => axn.resource[\"metadata\"][\"name\"]}\n      # spec\n    }\n\n    axn\n    |> Bonny.Axn.register_descendant(depl)\n    |> Bonny.Axn.register_descendant(svc)\n    |> success_event()\n  end\n\n  # delete the resource\n  def handle_event(%Bonny.Axn{action: :delete} = axn, _opts) do\n    # nothing to do because of owner reference\n    success_event(axn)\n  end\nend\n```\n\nLet's see the result of the above event handler:\n\n```elixir\nBonny.Axn.new!(\n  action: :add,\n  conn: nil,\n  resource: %{\n    \"apiVersion\" => \"example.com/v1\",\n    \"kind\" => \"MyApp\",\n    \"metadata\" => %{\n      \"name\" => \"foo\",\n      \"namespace\" => \"default\",\n      \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n    }\n  }\n)\n|> MyAppController.call([])\n|> Map.get(:descendants)\n```","ref":"controllers.html#owner-reference"},{"type":"extras","title":"The Status Subresource - Controllers","doc":"Controllers should use a resource's status subresource to communicate back data to the client. This can be results from underlaying APIs or stats. In your handler, use `Bonny.Axn.update_status/2` to update the status. Make sure the status subresource is represented in your CRD's schema.\n\n```elixir\ndefmodule StatusController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n\n  def handle_event(axn, _) do\n    axn\n    |> Bonny.Axn.update_status(fn status ->\n      put_in(status, [Access.key(:some, %{}), :field], \"foo\")\n    end)\n    |> Bonny.Axn.success_event()\n  end\nend\n```\n\n```elixir\nresource = %{\n  \"apiVersion\" => \"example.com/v1\",\n  \"kind\" => \"MyApp\",\n  \"metadata\" => %{\n    \"name\" => \"foo\",\n    \"namespace\" => \"default\",\n    \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n  }\n}\n\nBonny.Axn.new!(action: :add, conn: nil, resource: resource)\n|> StatusController.call([])\n|> Map.get(:status)\n```","ref":"controllers.html#the-status-subresource"},{"type":"extras","title":"Skipping Observed Generations - Controllers","doc":"One of the kubernetes operator best practices is observing generations. [This blog post explains it really well](https://alenkacz.medium.com/kubernetes-operator-best-practices-implementing-observedgeneration-250728868792). It is extremly useful especially when you work with status subresources to not get another `modify` event for updating the status.\n\nBonny skips observed generations if you add the `Bonny.Pluggable.SkipObservedGenrations` step to your controller.\n\n#","ref":"controllers.html#skipping-observed-generations"},{"type":"extras","title":"Preparations - Controllers","doc":"In order to use the `Bonny.Pluggable.SkipObservedGenrations` step on a custom resource, you have to enable the status subresource and define the correct openAPIV3 schema in your [CRD version file](./crd_versions.livemd#skipped-observed-generations):\n\n```elixir\ndefmodule MyOperator.API.V1.CronTab do\n  use Bonny.API.Version\n\n  @impl Bonny.API.Version\n  def manifest() do\n    defaults()\n    |> add_observed_generation_status()\n  end\nend\n\nMyOperator.API.V1.CronTab.manifest()\n```\n\n#","ref":"controllers.html#preparations"},{"type":"extras","title":"How it works - Controllers","doc":"`Bonny.Pluggable.SkipObservedGenrations` compares the current resource's fields `.metadata.generation` with the field defined by the `:observed_generation_key` option (`.status.observedGeneration` by default). It halts the pipeline if the two values match, i.e. if the resource generation had already been observed.\n\nYou can define for which actions this rule applies by adding the option `:actions` when placing the step. By default this rule applies to `[:add, :modify]` actions.\n\nFinally, before the resource status is applied, the module copies the value in `.metadata.generation` to the field defined by the `:observed_generation_key` option (`.status.observedGeneration` by default).\n\n#","ref":"controllers.html#how-it-works"},{"type":"extras","title":"Example - Controllers","doc":"This example shows how only `:reconcile` and `:delete` events are handled by the controller:\n\n```elixir\ndefmodule MyThirdResourceController do\n  use Bonny.ControllerV2\n\n  step Bonny.Pluggable.SkipObservedGenerations,\n    #  default\n    actions: [:add, :modify],\n    #  default\n    observed_generation_key: [\"status\", \"observedGeneration\"]\n\n\n  step :handle_event\n\n  def handle_event(axn, _) do\n    IO.puts(\"handling #{axn.action} event.\")\n    axn\n  end\nend\n\naction =\n  Kino.Input.select(\"Test Events\",\n    add: \"add\",\n    modify: \"modify\",\n    reconcile: \"reconcile\",\n    delete: \"delete\"\n  )\n```\n\n```elixir\nresource = %{\n  \"apiVersion\" => \"example.com/v1\",\n  \"kind\" => \"MyApp\",\n  \"metadata\" => %{\n    \"name\" => \"foo\",\n    \"namespace\" => \"default\",\n    \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\",\n    \"generation\" => 1\n  },\n  \"status\" => %{\"observedGeneration\" => 1}\n}\n\naxn = Bonny.Axn.new!(action: Kino.Input.read(action), conn: nil, resource: resource)\nMyThirdResourceController.call(axn, [])\n:ok\n```","ref":"controllers.html#example"},{"type":"extras","title":"Conditions - Controllers","doc":"[Conditions](https://maelvls.dev/kubernetes-conditions/) provide a way to communicate the resource's status in a machine readable state. One use case for conditions are [custom health checks in ArgoCD](https://argo-cd.readthedocs.io/en/stable/operator-manual/health/#custom-health-checks). If you define conditions on your resources, users of your operator can - when using ArgoCD - define a custom health check which changes the status of resources to. `degraded` if specified conditions fail.\n\n#","ref":"controllers.html#conditions"},{"type":"extras","title":"Preparations - Controllers","doc":"In order to use conditions on custom resources, they have to be [initialized in your CRD manifest](./crd_versions.livemd#skipped-observed-generations):\n\n```elixir\ndefmodule MyOperator.API.V1.CronTab2 do\n  use Bonny.API.Version\n\n  @impl Bonny.API.Version\n  def manifest() do\n    defaults()\n    |> add_conditions()\n  end\nend\n\nMyOperator.API.V1.CronTab2.manifest()\n```\n\n#","ref":"controllers.html#preparations"},{"type":"extras","title":"Usage - Controllers","doc":"I find the most elegant usage of conditions is in combination with a `with` statement. In the following code example, let's assume the controller needs to lookup a secret and a configmap in order to finally create a descendant resource:\n\n```elixir\ndefmodule MyFourthResourceController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n\n  def handle_event(axn, _) when axn.action in [:add, :modify, :reconcile] do\n    with {:secret, {:ok, secret}}   success_event()\n      |> set_condition(\"Descendant\", true, \"Descendant was created successfully\")\n    else\n      {:secret, {:error, error}} ->\n        axn\n        |> failure_event(message: error)\n        |> set_condition(\"Secret\", false, error)\n\n      {:configmap, axn, {:error, error}} ->\n        axn\n        |> failure_event(message: error)\n        |> set_condition(\"Configmap\", false, error)\n\n      {:descendant, axn, {:error, error}} ->\n        axn\n        |> failure_event(message: error)\n        |> set_condition(\"Descendant\", false, error)\n    end\n  end\n\n  # dummy functions:\n  def get_secret(_), do: {:ok, :secret}\n  def get_configmap(_), do: {:ok, :configmap}\n  def create_descendant(_, :secret, :configmap), do: {:error, \"Something went wrong\"}\nend\n\nBonny.Axn.new!(action: :add, conn: nil, resource: %{})\n|> MyFourthResourceController.call([])\n|> Map.get(:status)\n```","ref":"controllers.html#usage"},{"type":"extras","title":"Kubernetes Events - Controllers","doc":"Kubernetes events provide a way to report back to the client. A Kubernetes event always references the object to which the event relates. For a controller the regarding object would be the handled resource. The user can then use `kubectl describe` on the custom resource to see the events.\n\nUse `Bonny.Axn.success_event/2`, `Bonny.Axn.failure_event/2` or `Bonny.Axn.register_event/6` do register events in the `%Bonny.Axn{}` struct. Events are going to be applied to the cluster at the end of the Operator pipeline. There is no need to register a `step` for that.\n\n```elixir\ndefmodule MyResourceController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n\n  def handle_event(axn, _) when axn.action == :add do\n    Bonny.Axn.success_event(axn)\n  end\n\n  def handle_event(axn, _) when axn.action == :modify do\n    Bonny.Axn.failure_event(axn)\n  end\nend\n\naction = Kino.Input.select(\"Test Events\", add: \"Success\", modify: \"Failure\")\n```\n\n```elixir\nresource = %{\n  \"apiVersion\" => \"example.com/v1\",\n  \"kind\" => \"MyApp\",\n  \"metadata\" => %{\n    \"name\" => \"foo\",\n    \"namespace\" => \"default\",\n    \"uid\" => \"e19b6f40-3293-11ed-a261-0242ac120002\"\n  }\n}\n\naction = Kino.Input.read(action)\naxn = Bonny.Axn.new!(action: action, conn: nil, resource: resource)\nMyResourceController.call(axn, []) |> Map.get(:events)\n```","ref":"controllers.html#kubernetes-events"},{"type":"extras","title":"RBAC Rules - Controllers","doc":"Your controller might need special permissions on the kubernetes cluster. Maybe it needs to be able to read secrets. Or it has to be able to create pods. These permissions need to be reflected in the final manifest generated by `mix bonny.gen.manifest` through RBAC rules.\n\nYou can define such rules one by defining the `rbac_rules/0` callback. This callback should return a list of rbac rules of the following spec:\n\n \n\n```elixir\n@type rbac_rule :: %{\n  apiGroups: list(binary()),\n  resources: list(binary()),\n  binary()s: list(binary())}\n```\n\nYou can use the helper function `to_rbac_rule/1` to convert a tuple to an rbac rule. Its spec is:\n\n \n\n```elixir\n  @spec to_rbac_rule({\n    binary() | list(binary()),\n    binary() | list(binary()),\n    binary() | list(binary())\n  }) :: rbac_rule\n```\n\n```elixir\ndefmodule MySecondResourceController do\n  use Bonny.ControllerV2\n\n  @impl Bonny.ControllerV2\n  def rbac_rules() do\n    [\n      to_rbac_rule(\n        {\"apps/v1\", \"Deployment\", [\"get\", \"list\", \"create\", \"update\", \"patch\", \"delete\"]}\n      )\n    ]\n  end\nend\n\nMySecondResourceController.rbac_rules()\n```","ref":"controllers.html#rbac-rules"},{"type":"extras","title":"CRD Versions","doc":"# CRD Versions\n\n```elixir\nMix.install([:bonny])\n\nApplication.put_env(:bonny, :operator_name, \"livebook-operator\")\n```","ref":"crd_versions.html"},{"type":"extras","title":"CRD Definition and Versions - CRD Versions","doc":"When defining your operator (`use Bonny.Operator`), you have to implement the callback `crds/0` where you define your custom resources. A custom resource definition (CRD) is represented by a `%Bonny.API.CRD{}` struct which defines 4 fields:\n\n* `:scope` - either `:Namespaced` or `:Cluster`\n\n* `:group` - The API group of your controller / this resource\n\n* `:names` - A map with 3-4 keys defining the names of this resource.\n\n  * `plural`: name to be used in the URL: `/apis/ / / ` - e.g. crontabs\n  * `singular`: singular name to be used as an alias on the CLI and for display - e.g. crontab\n  * `kind`: is normally the CamelCased singular type. Your resource manifests use this. - e.g. CronTab\n  * `shortnames`: allow shorter string to match your resource on the CLI - e.g. [ct]\n\n* `versions`: list of API Version modules for this Resource, defaults to the versions in config.exs\n\n```elixir\ndefmodule MyOperator.Operator do\n  use Bonny.Operator, default_watch_namespace: \"default\"\n\n  step(:delegate_to_controller)\n\n  def controllers(_watching_namespace, _opts), do: []\n\n  def crds() do\n    [\n      %Bonny.API.CRD{\n        names: %{kind: \"CronTab\", plural: \"crontabs\", shortNames: [\"ct\"], singular: \"crontab\"},\n        group: \"example.com\",\n        versions: [MyOperator.API.V1.CronTab],\n        scope: :Namespaces\n      }\n    ]\n  end\nend\n```\n\nWe're going to look at [version manifest declaration](#version-manifest-declaration) in more detail in just a moment. For now, let's just define a simple API version `v1` for the `CronTab` custom resource with just defaults for all the fields. You do this by defining a module that starts with the API declared in the application configuration (`YourOperator.API.V1`), followed by the CRD name (`CronTab`). The module must `use Bonny.API.Version` which expects you to implement `manifest/0`.\n\n```elixir\ndefmodule MyOperator.API.V1.CronTab do\n  use Bonny.API.Version\n\n  @impl Bonny.API.Version\n  def manifest() do\n    defaults()\n    |> struct!(name: \"v1\", storage: true)\n  end\nend\n\nYourOperator.API.V1.CronTab.manifest()\n```\n\nNow, if we define a `CronTabController`, Bonny finds this version and add it to the CRD manifest.\n\n```elixir\ncrds =\n  [MyOperator.Operator]\n  |> Bonny.Mix.Operator.crds()\n  |> Ymlr.documents!()\n\nIO.puts(crds)\n```","ref":"crd_versions.html#crd-definition-and-versions"},{"type":"extras","title":"Version Manifest Declaration - CRD Versions","doc":"Our `V1.CronTab` module called the `defaults/0` macro from `manifest/0`. This macro helps initializing a generic version with no schema, subresources or additional printer columns. The `storage` flag is set to false (see [Multi-Version APIs](#multi-version-apis) further down). For the other flags `:served` and `:deprecated` such as the field `:deprecatedWarning`, assumptions are made.\n\nAn operator run in production might want to define at least a `:schema`, probably `:additionalPrinterColumns` and maybe `:subresources`. All these fields such as flags can be overriden in `manifest/0`.\n\n```elixir\ndefmodule YourOperator.API.V1Alpha1.Widget do\n  use Bonny.API.Version\n\n  @impl true\n  def manifest() do\n    struct!(\n      defaults(),\n      storage: true,\n      schema: %{\n        openAPIV3Schema: %{\n          type: :object,\n          properties: %{\n            spec: %{\n              type: :object,\n              properties: %{\n                foos_requested: %{type: :integer}\n              }\n            },\n            status: %{\n              type: :object,\n              properties: %{\n                foos_implemented: %{type: :integer}\n              }\n            }\n          }\n        }\n      },\n      additionalPrinterColumns: [\n        %{\n          name: \"requested_foos\",\n          type: :integer,\n          description: \"Number of foos requested\",\n          jsonPath: \".spec.foos_requested\"\n        },\n        %{\n          name: \"implemented_foos\",\n          type: :integer,\n          description: \"Number of foos implemented\",\n          jsonPath: \".status.foos_implemented\"\n        }\n      ],\n      subresources: %{\n        status: %{}\n      }\n    )\n  end\nend\n\nYourOperator.API.V1Alpha1.Widget.manifest()\n```","ref":"crd_versions.html#version-manifest-declaration"},{"type":"extras","title":"The Status Subresource - CRD Versions","doc":"In the [controllers guide](./controllers.livemd#the-status-subresource) we explain the importance of using of the status subresource. In order to use the status subresource, it has to be enabled and its schema has to be defined in the CRD. You can see an example in the code snipped above in the [`YourOperator.API.V1Alpha1.Widget`](#version-manifest-declaration).\n\nTwo special use cases of the status subresource are [skipping obeserved generations](./controllers.livemd#skipping-observed-generations) and [conditions](./controllers.livemd#conditions). In order to use these concepts with custom resources, they have to be configured on the CRD. When `use`ing `Bonny.API.Version`, helper functions `add_observed_generation_status/1` and `add_conditions/1` are imported to your module. Use them to add the required fields to your manifest:\n\n```elixir\ndefmodule YourOperator.API.V1Alpha1.Feature do\n  use Bonny.API.Version\n\n  @impl true\n  def manifest() do\n    defaults()\n    |> struct!(\n      schema:\n        %{\n          # your openAPIV3schema\n        }\n    )\n    # initialize the usage of the observed generations pluggable step\n    |> add_observed_generation_status()\n    # initialize the usage of conditions.\n    |> add_conditions()\n  end\nend\n\nYourOperator.API.V1Alpha1.Widget.manifest()\n```","ref":"crd_versions.html#the-status-subresource"},{"type":"extras","title":"Multi-Version APIs - CRD Versions","doc":"There is some [documentation](https://book.kubebuilder.io/multiversion-tutorial/tutorial.html) about multi-version apis for the kubebuilder. Obviousely, that one is for creating a kubernetes controller in Go, but it's a good read nontheless. This is how it begins:\n\n> Most projects start out with an alpha API that changes release to release. However, eventually, most projects will need to move to a more stable API. Once your API is stable though, you can't make breaking changes to it. That's where API versions come into play.\n\n#","ref":"crd_versions.html#multi-version-apis"},{"type":"extras","title":"Conversion - CRD Versions","doc":"Webhooks are currently not implemented in Bonny. There is the module [`bonny_plug`](https://hexdocs.pm/bonny_plug/readme.html) that can be used to implement them. There might be a neater integration of the two in the future, though.\n\nBonny already lets you define a version as the `hub`. The only thing this does right now is it sets the `storage` flag to `true` in the generated manifest.\n\n```elixir\ndefmodule YourOperator.API.V1.CronTab do\n  use Bonny.API.Version,\n    hub: true\n\n  @impl Bonny.API.Version\n  # storage: true not needed here.\n  def manifest(), do: defaults(name: \"v1\")\nend\n\nYourOperator.API.V1.CronTab.manifest()\n```\n\n#","ref":"crd_versions.html#conversion"},{"type":"extras","title":"Storage Versions - CRD Versions","doc":"Even if you define multiple versions for the same resource, Kubernetes is only going to store the data in one version - the **storage version**.\n\n> Note that multiple versions may exist in storage if they were written before the storage version changes -- changing the storage version only affects how objects are created/updated after the change.\n\nAs mentioned above, there are to ways to define the storage version, by passing `hub: true` as an option to `use Bonny.API.Version` or by setting `storage: true` in `manifest/0`.","ref":"crd_versions.html#storage-versions"},{"type":"extras","title":"Testing","doc":"# Testing\n\n```elixir\nMix.install([:bonny, :inflex])\n\nApplication.put_env(:bonny, :operator_name, \"livebook-operator\")\n\nExUnit.start(autorun: false)\n```","ref":"testing.html"},{"type":"extras","title":"The Controller to Test - Testing","doc":"In this guide we're going to create a simple controller and write a test for it. The controller's custom resource is called `ConfigMapToPluralize` and we expect the controller to map the resource to a `ConfigMap` on the cluster. The `ConfigMap` should contain the same fields as the `ConfigMapToPluralize` but the fielt's values are pluralized.\n\n#","ref":"testing.html#the-controller-to-test"},{"type":"extras","title":"Example - Testing","doc":"For the following `ConfigMapToPluralize` resource:\n\n```yaml\napiVersion: example.com/v1\nkind: ConfigMapToPluralize\nmetadata:\n  name: foo\n  namespace: default\ndata:\n  first: House\n  second: Hero\n```\n\nthe controller will create the following `ConfigMap`:\n\n```yaml\napiVersion: v1\nkind: ConfigMap\nmetadata:\n  name: foo\n  namespace: default\ndata:\n  first: Houses\n  second: Heroes\n```\n\n \n\n#","ref":"testing.html#example"},{"type":"extras","title":"The CRD API V1 - Testing","doc":"Let's define the API version `V1` for the `ConfigMapToPluralize` CRD. It defines a schema with a property `.data` which is an object allowing for arbitrary fields with string values.\n\n```elixir\ndefmodule V1.ConfigMapToPluralize do\n  use Bonny.API.Version,\n    hub: true\n\n  def manifest() do\n    struct!(\n      defaults(),\n      schema: %{\n        openAPIV3Schema: %{\n          type: :object,\n          properties: %{\n            data: %{\n              type: :object,\n              additionalProperties: %{\n                type: :string\n              },\n              \"x-kubernetes-preserve-unknown-fields\": true\n            }\n          }\n        }\n      }\n    )\n  end\nend\n```\n\n#","ref":"testing.html#the-crd-api-v1"},{"type":"extras","title":"The Controller - Testing","doc":"The `ConfigMapToPluralizeController` handles `:add` and `:modify` and `:reconcile` events through the same function where the `ConfigMap` with pluralized field values is created and registered as descendant.\n\n```elixir\ndefmodule ConfigMapToPluralizeController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n\n  def handle_event(%Bonny.Axn{action: action} = axn, _opts)\n      when action in [:add, :modify, :reconcile] do\n    %Bonny.Axn{resource: resource} = axn\n\n    name = K8s.Resource.FieldAccessors.name(resource)\n    namespace = K8s.Resource.FieldAccessors.namespace(resource)\n\n    new_data =\n      resource\n      |> Map.get(\"data\")\n      |> Enum.map(fn {key, value} ->\n        {key, Inflex.pluralize(value)}\n      end)\n      |> Enum.into(%{})\n\n    cm = %{\n      \"apiVersion\" => \"v1\",\n      \"kind\" => \"ConfigMap\",\n      \"metadata\" => %{\n        \"name\" => name,\n        \"namespace\" => namespace\n      },\n      \"data\" => new_data\n    }\n\n    axn\n    |> register_descendant(cm)\n    |> success_event()\n  end\n\n  def handle_event(axn, _opts) do\n    # since we added the owner reference above, there's nothing to do here.\n    # Kubernetes will delete the referencing objects i.e. the ConfigMap for us.\n    success_event(axn)\n  end\nend\n```","ref":"testing.html#the-controller"},{"type":"extras","title":"Testing the controller - Testing","doc":"Testing a Bonny controller is similar to testing a Phoenix controller. Controllers use the `%Bonny.Axn{}` token to register descending resources, update resource status and registering Kubernetes events. In our test, we need to assert the state of the returned `Bonny.Axn{}` struct is as expected.\n\n#","ref":"testing.html#testing-the-controller"},{"type":"extras","title":"Helper Module `Bonny.Axn.Test` - Testing","doc":"`Bonny.Axn.Test` is a helper module for tests. It provides a function `axn/2` to create a `%Bonny.Axn{}` token and other helper functions which are imported to your test when using the helper module.\n\n```elixir\ndefmodule ConfigMapToPluralizeControllerTest do\n  use ExUnit.Case, async: true\n  use Bonny.Axn.Test\n\n  #  Module Under Test\n  alias ConfigMapToPluralizeController, as: MUT\n\n  setup do\n    cm_to_pluralize = %{\n      \"apiVersion\" => \"example.com/v1\",\n      \"kind\" => \"ConfigMapToPluralize\",\n      \"metadata\" => %{\n        \"namespace\" => \"default\",\n        \"name\" => \"test-1\"\n      },\n      \"data\" => %{\n        \"first\" => \"House\",\n        \"second\" => \"Hero\"\n      }\n    }\n\n    [\n      axn: axn(:add, resource: cm_to_pluralize, conn: %K8s.Conn{})\n    ]\n  end\n\n  test \"registers descending ConfigMap with pluralized fields\", %{axn: axn} do\n    assert [cm] = axn |> MUT.call([]) |> descendants()\n    assert \"Houses\" == cm[\"data\"][\"first\"]\n    assert \"Heroes\" == cm[\"data\"][\"second\"]\n  end\n\n  test \"registers a success event\", %{axn: axn} do\n    assert [event] = axn |> MUT.call([]) |> events()\n    assert :Normal == event.event_type\n  end\nend\n\nExUnit.run()\n```","ref":"testing.html#helper-module-bonny-axn-test"},{"type":"extras","title":"Integration Testing - Testing","doc":"You can also test your code against a real Kubernetes cluster setup locally (e.g. with `k3d`) and in your CI. You will need to setup a `%K8s.Conn{}` defines the connection your cluster **but is oonly used for the integration tests**. Have a look at the follwing files in the Bonny repo:\n\n- `test/support/integration_helper.ex` - defines a `conn/0` function\n- `test/bonny/controller_v2_integration_test.exs` - implements integration tests using the helper above.","ref":"testing.html#integration-testing"},{"type":"extras","title":"The Operator","doc":"# The Operator\n\n```elixir\nMix.install([:kino, :bonny])\n\ndefmodule MyApp.API.V1.TestResource do\n  use Bonny.API.Version\n  def manifest(), do: defaults()\nend\n\ndefmodule MyApp.Controller.GenericController do\n  use Bonny.ControllerV2\n\n  step :handle_event\n  def handle_event(axn, _), do: axn\nend\n\nLogger.configure(level: :info)\n```","ref":"the_operator.html"},{"type":"extras","title":"About this Livebook - The Operator","doc":"This livebook connects to a kubernetes cluster. Please define here the connection to a cluster you have access to:\n\n```elixir\n{:ok, conn} = K8s.Conn.from_file(\"~/.kube/config\", context: \"k3d-bonny-ex\")\n```","ref":"the_operator.html#about-this-livebook"},{"type":"extras","title":"The Operator - The Operator","doc":"The operator defines custom resources, watch queries and their controllers and serves as the entry point to the watching and handling processes.\n\nOverall, an operator has the following responsibilities:\n\n- to provide a wrapper for starting and stopping the\n  operator as part of a supervision tree\n- To define the resources to be watched together with the\n  controllers which handle action events on those resources.\n- to define an initial pluggable pipeline containing the step `:delegate_to_controller` for all action events\n  to pass through\n- To define any custom resources ending up in the manifest\n  generated by `mix bonny.gen.manifest`\n\n```elixir\ndefmodule MyApp.Operator do\n  use Bonny.Operator, default_watch_namespace: \"default\"\n\n  @impl Bonny.Operator\n  def crds() do\n    [\n      %Bonny.API.CRD{\n        group: \"example.com\",\n        scope: :Namespaced,\n        names: Bonny.API.CRD.kind_to_names(\"MyCustomResource\"),\n        versions: [MyApp.API.V1.TestResource]\n      }\n    ]\n  end\n\n  step :delegate_to_controller\n  step Bonny.Pluggable.ApplyStatus\n  step Bonny.Pluggable.ApplyDescendants\n\n  @impl Bonny.Operator\n  def controllers(watching_namespace, _opts) do\n    [\n      %{\n        query:\n          K8s.Client.watch(\"example.com/v1\", \"MyCustomResource\", namespace: watching_namespace),\n        controller: MyApp.Controller.GenericController\n      },\n      %{\n        query: K8s.Client.watch(\"apps/v1\", \"Deployment\", namespace: watching_namespace),\n        controller: MyApp.Controller.GenericController\n      }\n    ]\n  end\nend\n```","ref":"the_operator.html#the-operator"},{"type":"extras","title":"The `crds/0` Callback - The Operator","doc":"By implementing the `crds/0` callback, you tell Bonny what custom resources your operator defines. It is read only when running `mix bonny.gen.manifest` in order to generate the operator manifest:\n\n```elixir\ncrds =\n  [MyApp.Operator]\n  |> Bonny.Mix.Operator.crds()\n  |> Ymlr.documents!()\n\nIO.puts(crds)\n```\n\nIn order to run the operator in this livebook, we have to apply the CRD to the cluster. This step has nothing to do with the operator directly. We just do it in order to run the operator.\n\n```elixir\ncrds\n|> YamlElixir.read_all_from_string!()\n|> Bonny.Resource.apply_async(conn, field_manager: \"livebook\")\n|> Enum.each(fn {_, {:ok, applied_crd}} -> dbg(applied_crd) end)\n```","ref":"the_operator.html#the-crds-0-callback"},{"type":"extras","title":"The controllers/2 Callback - The Operator","doc":"In `controllers/2` we define the queries and their event handlers, i.e. controllers. function should return a list where each element of the list is a map with these 2 keys:\n\n- `:query` - A list operation of type `K8s.Operation.t()`. Bonny will watch the cluster with this operation and forward all events to the `:controller`.\n- `:controller` - A controller (See the [controller guide](controllers.livemd)) or any other `Pluggable` step. Accepts a module or a `{controller :: module(), init_opts :: keyword()}` tuple. If a tuple is given, the init_opts are passed to the controller's `init/1` function.\n\nIf you managed to define a valid `conn` above, you can now run the operator defined above in this livebook. The code below starts the operator and shows the supervision tree. Note how the operator starts an `EventRecorder` and two proceses for each controller defined in `controllers/2`. These two processes are the `Watcher` and the `Reconciler`. The `Watcher` watches for `ADD`, `MODIFY` and `DELETE` events in the cluster. The `Reconciler` regularly creates `:reconcile` events for each resource found in the cluster.\n\n```elixir\n{:ok, supervisor} = Supervisor.start_link([{MyApp.Operator, conn: conn}], strategy: :one_for_one)\nKino.Process.render_sup_tree(supervisor)\n```","ref":"the_operator.html#the-controllers-2-callback"},{"type":"extras","title":"Adding the Operator to your Supervisor - The Operator","doc":"Once your operator is implemented, you need to add it to your application supervision tree. You can pass `:conn` and `:watch_namespace` as init arguments if you like. If you don't pass them, `:conn` will be retrieved from the callback in your `config.exs` and `:watch_namespace` will fall back to the `:default_watch_namespace` you configured your operator with.\n\n```elixir\ndefmodule MyOperator.Application do\n  use Application\n\n  def start(_type, env: env) do\n    children = [\n      {MyOperator.Operator, conn: MyOperator.K8sConn.get!(env), watch_namespace: :all}\n    ]\n\n    opts = [strategy: :one_for_one, name: MyOperator.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"the_operator.html#adding-the-operator-to-your-supervisor"},{"type":"extras","title":"Leader Election - Running Multiple Replicas - The Operator","doc":"From https://docs.okd.io/latest/operators/operator_sdk/osdk-leader-election.html:\n\n> During the lifecycle of an Operator, it is possible that there may be more than one instance running at any given time, for example when rolling out an upgrade for the Operator. In such a scenario, it is necessary to avoid contention between multiple Operator instances using leader election. This ensures only one leader instance handles the reconciliation while the other instances are inactive but ready to take over when the leader steps down.\n\nIn other words, if you want to run multiple replicas of your oprator, you need to turn on leader election.\n\nLeader election is enabled per default. To disable it, you have to pass the `enable_leader_election: false` option when [adding the operator to your Supervisor](#adding-the-operator-to-your-supervisor):\n\n \n\n```elixir\ndefmodule MyOperator.Application do\n  use Application\n\n  def start(_type, env: env) do\n    children = [\n      {MyOperator.Operator,\n       conn: MyOperator.K8sConn.get!(env),\n       watch_namespace: :all,\n       enable_leader_election: false} # <-- disables the leader elector\n    ]\n\n    opts = [strategy: :one_for_one, name: MyOperator.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"the_operator.html#leader-election-running-multiple-replicas"},{"type":"extras","title":"Pluggable Pipeline and Steps - The Operator","doc":"The operator implements a [Pluggable](https://hex.pm/packages/pluggable) pipeline, the controller represents one step in this pipeline but can contain sub-steps as well.\n\nBonny comes with a few steps to your convenience. In most caes it makes sense to add at least `Bonny.Pluggable.ApplyDescendants` and `Bonny.Pluggable.ApplyStatus` to the end of your operator pipeline.\n\n- `Bonny.Pluggable.AddManagedByLabelToDescendants` - Adds the `app.kubernetes.io/managed-by` label to all descendants registered within the pipeline.\n- `Bonny.Pluggable.AddMissingGVK` - Add fields `apiVersion` and `kind` to the resource if they are missing.\n- `Bonny.Pluggable.ApplyDescendants` - applies all the descendants added to the `%Bonny.Axn{}` struct.\n- `Bonny.Pluggable.ApplyStatus` - applies the status of the given `%Bonny.Axn{}` struct to the status subresource.\n- `Bonny.Pluggable.Finalizer` - declares a finalizer and its implementation.\n- `Bonny.Pluggable.Logger`- logs an action event and when status, descendants and events are applied to the cluster. If desired, it makes sense to be placed as first step in your operator pipeline but can also be added to a controller pipeline.\n- `Bonny.Pluggable.SkipObservedGenerations` - halts the pipelines for a defined list of actions if the observed generation equals the resource's generation. You'll find further documentation on this module in the [Controller](controllers.livemd) guide.","ref":"the_operator.html#pluggable-pipeline-and-steps"},{"type":"extras","title":"Contributing","doc":"# Contributing\n\nContributing to Bonny is as easy as opening a PR. Please make sure your code is tested and add a Changelog.","ref":"contributing.html"},{"type":"extras","title":"Testing - Contributing","doc":"If you're writing tests, you might also want to check out the [`k8s` library testing guide](https://hexdocs.pm/k8s/testing.html).\n\n#","ref":"contributing.html#testing"},{"type":"extras","title":"Integration Testing - Contributing","doc":"A `Makefile` is included for help with integration testing against k3d. You're gonna need k3d installed on your machine to run integration tests.\n\nRun `make help` for a list of commands:\n\n```\ntest.integration               Run integration tests using k3d `make cluster`\ntest.watch                     Run all tests with mix.watch\ntest                           Run all tests\n```\n\n##","ref":"contributing.html#integration-testing"},{"type":"extras","title":"Integration environment variables - Contributing","doc":"- `TEST_KUBECONFIG` path to kubeconfig file for integration tests, default: \"./integration.yaml\"","ref":"contributing.html#integration-environment-variables"},{"type":"extras","title":"Migrations","doc":"# Migrations","ref":"migrations.html"},{"type":"extras","title":"Migrating from 0.5 to a newer version - Migrations","doc":"In this version of, Bonny comes with slightly a new concept. In this version you have to define an operator and add it to your application's supervision tree. Also, the processing of events are done in a Plug-like pipeline leveraging the [`Pluggable`](https://hex.pm/packages/pluggable) library. This makes controllers easeir to test but also easier to customize. See for yourself.\n\n#","ref":"migrations.html#migrating-from-0-5-to-a-newer-version"},{"type":"extras","title":"Option 1: Use `mix bonny.init` on a fresh project - Migrations","doc":"The probably easiest way is to start with a plain Elixir project and set up your\noperator using `mix bonny.init`. Since you already know what resources and\ncontrollers you need, this will initiate your operator, CRDs, versions and\ncontrollers for you.\nYou just have to copy your controller implementation over to the generated\ncontrollers and bring it into a `Pluggable` form.\n\n#","ref":"migrations.html#option-1-use-mix-bonny-init-on-a-fresh-project"},{"type":"extras","title":"Option 2: Manual migration - Migrations","doc":"##","ref":"migrations.html#option-2-manual-migration"},{"type":"extras","title":"Step 1: Create your Opeator - Migrations","doc":"Create a new module (e.g. `YourProject.Operator`) which uses `use Bonny.Operator`,\nimplement `crds/0` and `controllers/2` according to the [Operator Guide](./the_operator.livemd)\nand add it to your supervision tree.\n\n##","ref":"migrations.html#step-1-create-your-opeator"},{"type":"extras","title":"Step 2: Create your API versions - Migrations","doc":"For each custom resource your operator defines and each version the resource\nsupports, create the corresponding module:\n\n```elixir\n# lib/your_operator/api/v1/cron_tab.ex\ndefmodule YourOperator.API.V1.CronTab do\n  use Bonny.API.Version\n\n  @impl Bonny.API.Version\n  def manifest(), do: struct!(defaults(), storage: true)\nend\n```\n\n```elixir\n# lib/your_operator/api/v1alpha1/cron_tab.ex\ndefmodule YourOperator.API.V1Alpha1.CronTab do\n  use Bonny.API.Version\n\n  @impl Bonny.API.Version\n  def manifest(), do: defaults()\nend\n```\n\n**Note that one and only one version of the same custom resource has to be flagged with `storage: true`.**\n\n##","ref":"migrations.html#step-2-create-your-api-versions"},{"type":"extras","title":"Step 3: Additional Printer Columns - Migrations","doc":"Additional printer columns belong to CRD API versions, not to controllers. Therefore, if your\ncontroller defined additional printer columns, move those over to the version you just created.\nModify `manifest/0` for this purpose.\n\n```elixir\n# lib/your_operator/api/v1/cron_tab.ex\ndefmodule YourOperator.API.V1Alpha1.CronTab do\n  use Bonny.API.Version\n\n  @impl Bonny.API.Version\n  def manifest() do\n    struct!(\n      defaults(),\n      additionalPrinterColumns: [\n        %{name: \"foos\", type: :integer, description: \"Number of foos\", jsonPath: \".spec.foos\"}\n      ]\n    )\n  end\nend\n```\n\n##","ref":"migrations.html#step-3-additional-printer-columns"},{"type":"extras","title":"Step 4: Update your Controllers - Migrations","doc":"Also see the [Controllers Guide](./controllers.livemd)\n\n- Change `use Bonny.Controller` to `use Bonny.ControllerV2`\n- If you have defined additional RBAC rules via `@rule {apiGroup, resources_list, verbs_list}`, implement the `rbac_rules/0`.\n- If you have defined custom names via `@names %{...}`, the resource scope (e.g. `@scope :cluster`) or an API group (e.g. `@group \"example.com\"`),\n  add these values to the CRD in your Operator (see above)\n- Bring your controller to a `Pluggable` form. See the [Controllers Guide](./controllers.livemd)\n\nAfter having migrated all controllers, re-generate your manifest using `mix bonny.gen.manifest`.","ref":"migrations.html#step-4-update-your-controllers"},{"type":"extras","title":"Migrating from 0.4 to 0.5 - Migrations","doc":"Version 0.5 comes with some major changes. Please read through this migration guide before upgrading.\n\n#","ref":"migrations.html#migrating-from-0-4-to-0-5"},{"type":"extras","title":"Elixir Version - Migrations","doc":"With version 0.5, bonny moved Elixir support from \\~> 1.9 to \\~> 1.10.\n\n#","ref":"migrations.html#elixir-version"},{"type":"extras","title":"Config - Migrations","doc":"The dependency on `:k8s` was upgraded from `~> 0.4.0` to `~> 1.1`. With version `1.0`,\n`:k8s` brought some major changes. Mainly the way the connection to the cluster\nis configured. While pre `1.0`, connections were configured in `config.exs`, in `1.0`\nupwards, they had to created and passed to the client by the caller. This change\naffects `:bonny`, too.\n\nStarting with version `0.5`, you no longer have to configure `:k8s`. This means\nyou can remove this block completely as it has no effect:\n\n```elixir\nconfig :k8s,\n clusters: ...\n```\n\nWith `0.5`, `:bonny` however has to be configured with a new option `:get_conn`. The value of\nthis configuration option is supposed to be an MFA tuple that tells bonny how to get\nthe connection struct. The function is called by bonny and is expected to return\neither `{:ok, K8s.Conn.t()}` or a `K8s.Conn.t()` directly.\n\n```elixir\nconfig :bonny,\n  get_conn: {MyModule, :get_the_connection},\n```\n\nYou can use helpers defined in `:k8s` to get the connection:\n\n```elixir\nconfig :bonny,\n  get_conn: {K8s.Conn, :from_file, [\"~/.kube/config\", [context: \"optional-alternate-context\"]]},\n```\n\nor, when configuring bonny to run in your cluster:\n\n```elixir\nconfig :bonny,\n  get_conn: {K8s.Conn, :from_service_account, []}\n```","ref":"migrations.html#config"},{"type":"extras","title":"Bonny Mix Tasks","doc":"# Bonny Mix Tasks\n\nThere are a number of mix tasks to help create a Kubernetes operator.\n\n`mix help | grep bonny`","ref":"mix_tasks.html"},{"type":"extras","title":"Initialize your Operator (`mix bonny.init`) - Bonny Mix Tasks","doc":"To add bonny to your existing elixir project (`mix new your_operator`), this tasks\nhelps you to generate application configuration and initializing your test suite.\n\nJust run `mix bonny.init`, the task will ask you questions about your operator\nand initialize it.","ref":"mix_tasks.html#initialize-your-operator-mix-bonny-init"},{"type":"extras","title":"Controller Generation (`mix bonny.gen.controller`) - Bonny Mix Tasks","doc":"Guides you through the creation of a controller. Normally, a controller of an operator\nwatches a custom resource defined by that same operator. This is the default flow through\nthis mix task.\nHowever, you can also create a controller that watches and reacts on events of\ncore resources or custom resources defined by another operator.\n\nSee the [controllers guide](controllers.livemd) for further information about controllers.\n\nAfter the mix task ran through, open up your controller and add functionality for your\nresource's lifecycles:\n\n- Apply (or Add/Modify)\n- Delete\n- Reconcile; periodically called with each every instance of a CRD's resources\n\nIdeally you'd also open up the generated CRD versions and add OpenAPIV3 schema,\nadditional printer columns, etc.\n\nYour operator can also have multiple controllers if you want to watch multiple\nresources in your operator. Just run the mix task again.\n\n#","ref":"mix_tasks.html#controller-generation-mix-bonny-gen-controller"},{"type":"extras","title":"Generating Kubernetes manifest for operator (`mix bonny.gen.manifest`) - Bonny Mix Tasks","doc":"This will generate the entire manifest for this operator including:\n\n- CRD manifests\n- RBAC\n- Service Account\n- Operator Deployment\n\nThe operator manifest generator requires the `image` flag to be passed if you plan to deploy the operator in your cluster. This is the docker image URL of your operators docker image created by `mix bonny.gen.docker` above.\n\n```shell\nmix bonny.gen.manifest --image ${BONNY_IMAGE}\n```\n\nYou may _omit_ the `--image` flag if you want to generate a manifest _without the deployment_ so that you can develop locally running the operator outside of the cluster.\n\nBy default the manifest will generate the service account and deployment in the \"default\" namespace.\n\n_To set the namespace explicitly:_\n\n```shell\nmix bonny.gen.manifest --out - -n test\n```\n\n_Alternatively you can apply it directly to kubectl_:\n\n```shell\nmix bonny.gen.manifest --out - -n test | kubectl apply -f - -n test\n```\n\n#","ref":"mix_tasks.html#generating-kubernetes-manifest-for-operator-mix-bonny-gen-manifest"},{"type":"extras","title":"Generating a dockerfile (`mix bonny.gen.dockerfile`) - Bonny Mix Tasks","doc":"The following command will generate a dockerfile _for your operator_. This will need to be pushed to a docker repository that your Kubernetes cluster can access.\n\nAgain, this Dockerfile is for your operator, not for the pods your operator may deploy.\n\nYou can skip this step when developing by running your operator _external_ to the cluster.\n\n```shell\nmix bonny.gen.dockerfile\n\nexport BONNY_IMAGE=YOUR_IMAGE_NAME_HERE\ndocker build -t ${BONNY_IMAGE} .\ndocker push ${BONNY_IMAGE}:latest\n```","ref":"mix_tasks.html#generating-a-dockerfile-mix-bonny-gen-dockerfile"}],"content_type":"text/markdown"}